Fetchmail Release Notes
=======================

This file is in Unicode charset with UTF-8 encoding.
All dates are in Universal Time unless otherwise noted.

(The `lines' figures total .c, .h, .l, and .y files under version control.
Abbreviations in parentheses are the maintainers who committed the respective
change.  MA = Matthias Andree, ESR = Eric S. Raymond, RF = Rob Funk.)

# ADVANCE WARNING OF FEATURES TO BE REMOVED OR CHANGED IN FUTURE VERSIONS
(There are no plans to remove features from a 6.5.X release, but they may be
removed from a 6.6.0 or newer release.)
* Support for operating systems that are not sufficiently POSIX compliant may be
  removed or operation on such systems may be suboptimal for future releases.
* Future fetchmail releases may require compilers and operating systems
  that adhere to standards issued 2011 or later. (See README for requirements.)
* Future fetchmail releases may tighten up security and lean towards
  it a bit more by, for instance, implementing recommendations from
  RFC-7817 or RFC-8314. This may, for instance, require that TLS v1.1
  or newer be used.
* The MX and host alias DNS lookups that fetchmail performs in multidrop mode
  are based on assumptions that are rarely met in practice, somewhat defective,
  deprecated and may be removed from a future fetchmail version.
  They have never supported IPv6 (including IPv6-mapped IPv4).
  Non-DNS based alias keywords such as "aka" will remain in fetchmail.
* The monitor and interface options may be removed from a future fetchmail
  version as they are not reasonably portable across operating systems.
* POP2 is obsolete, support will be removed from a future fetchmail version.
* IMAP2 and IMAP4 (not IMAP4r1) are obsolete, support may be removed from a
  future fetchmail version.
* RPOP is obsolete, support will be removed from a future fetchmail release.
* The multidrop To/Cc guessing code along with the fragile duplicate suppressor
  is deprecated and may be removed from a future release.
* The "envelope Received" option may be removed from a future release, because
  the Received header was never meant to be machine-readable, the format varies
  widely, and various other differences in behavior make parsing Received an
  unreliable undertaking. The envelope option as such will remain though, in
  order to support Delivered-To, X-Envelope-To, X-Original-To and similar.
  See also <http://home.pages.de/~mandree/mail/multidrop>.
* The "protocol auto" default inside fetchmail may be removed from a future
  fetchmail release. Explicit configuration of the protocol is recommended.
* Kerberos IV support may be removed from a future fetchmail release.
* Kerberos 5 support may be removed from a future fetchmail release.
  (Although GSS-API support should remain as long as it's viable.)
* The --principal option may be removed from a future fetchmail release.
* SIGHUP wakeup support may be removed from a future fetchmail release and
  cause fetchmail to terminate - it was broken for many years.
* The maintainer may migrate fetchmail to C++, and impose further requirements
  (dependencies), such as Boost or other class libraries.
* The softbounce option default will change to "false" in the next release.
* The --bsmtp - mode of operation may be removed in a future release.
* Fetchmailconf is deprecated and will be removed from a future release.
* Fetchmail does not guarantee compatibility with EOL OpenSSL versions. Support
  for end-of-life OpenSSL versions may be removed even from patchlevel releases.
* Nonstandard or by today's standards insufficiently secure authentication
  schemes (such as OPIE, RPA) may be removed from future fetchmail versions.
* Nonstandard protocol extensions (such as SDPS/*ENV) may be removed from future
  fetchmail versions.
* --auth ssh may be removed from future fetchmail versions. Use --auth implicit.
* Future fetchmail releases (even minor ones) may change undocumented parts of
  the .netrc parser in incompatible ways to enhance compatibility with typical
  ftp(1) .netrc parsers.
* wolfSSL support may be removed from fetchmail's next major release.
* AUTH LOGIN always remained in draft state and never became an IETF RFC. Most
  servers offering this should also offer AUTH PLAIN, so AUTH LOGIN may be removed
  from future versions of fetchmail.

# KNOWN BUGS AND WORKAROUNDS
* Fetchmail does not handle messages without Message-ID header well
  (See sourceforge.net bug #780933)
* Fetchmail currently uses 31-bit signed integers in several places
  where unsigned and/or wider types should have been used. Please report
  issues with this.
* BSMTP is mostly untested and errors can cause corrupt output.
* Fetchmail does not track pending deletes across crashes.
* The command line interface is sometimes a bit stubborn, for instance,
  fetchmail -s doesn't work with a daemon running.
* Linux systems may return duplicates of an IP address in some circumstances if
  no or no global IPv6 addresses are configured.
  (No workaround. Ubuntu Bug#582585, Novell Bug#606980.)
* Kerberos 5 may be broken, particularly on Heimdal, and provide bogus error
  messages. This will not be fixed, because the maintainer has no Kerberos 5
  server to test against. Use GSSAPI.
* For IMAP connections, fetchmail will print "will idle after poll" in
  verbose mode even though --idle is not given, as an artifact of the 6.4.22
  security fixes. Fetchmail means "could idle after poll", but this would
  have required another loop through the translators.
* aka ... hostnames are not considered for upstream server X.509 certificate
  verification, aka was meant for alias detection with multidrop mailboxes.
* When compiled against wolfSSL, note that it is not a feature-complete
  emulation of OpenSSL. Main functionality is given, but some minor details
  may not work the same as in OpenSSL builds.
* When compiled against LibreSSL (due to licensing, this only works on OpenBSD
  where LibreSSL is part of the OS), note that LibreSSL is somewhat behind
  recent OpenSSL versions, so prefer OpenSSL to LibreSSL if you can.
* FreeBSD's OPIE implementation cannot be found when using a C++ compiler.
  This should not affect the normal build, which uses a C compiler.
* Using ccache may trigger "implicit fallthrough" warnings because
  the comments that, for instance, GCC understands, are removed by ccache's
  separate preprocessing.  Fixing this portably requires C++17.
* Fetchmail's RFC-2047 encoder (used for localized Subject: lines of locally-
  originated e-mail messages) is simplistic and violates the RFC-2047
  requirement that multibyte characters must not be split across
  encoded-words.
* Future releases of fetchmail may actively refuse to operate on operating
  systems that are not safe beyond the year 2038.

-------------------------------------------------------------------------------
fetchmail-6.6.6 (released 2026-06-24, 32443 LoC):

## CRITICAL BUGFIX FOR IMAP:
* The IMAP client, which has always used message indexes for the selected
  mailbox, did not abort when receiving an EXPUNGE response - which changes
  message numbers inside the mailbox.  Unlike UIDs, the message numbers are
  not stable and fetchmail does not have internal interfaces to track which
  messages are deleted, and adding those to a 6.6.X release would be too
  risky, and switching to UID is also too big a change, so we have no
  choice but to abort the session when seeing an EXPUNGE response without
  our own EXPUNGE request, to avoid marking the wrong message as seen/deleted
  or skip the wrong one, or assume the wrong message size.
  Earl Chew reported this versus Yahoo Mail via Gitlab Work Item #91, which
  automatically expunges messages that are marked with the \Deleted flag.

  This has one new message for which we do not have translations yet,
  it is urgent to get the fix in the field.

-------------------------------------------------------------------------------
fetchmail-6.6.5 (released 2026-06-17, 32433 LoC):

## SECURITY BUGFIX
* POP3 with RPA: fix calculation of buffer sizes to avoid buffer overflow
  on long service challenges with long user IDs, which would smash our stack.
    Triggering this requires that 1. RPA is enabled at compile time
  (non-default, which is discouraged in autotools, and possible but not
  documented nor supported in meson), and the username (--user option, or user
  in the rcfile) contains @compuserve.com anywhere, and the server supports an
  AUTH command without arguments (which is a non-standard local extension), and
  that it offers RPA authentication in response to that command.

  This was reported based on an incomplete semi-wrong AI report with an
  incomplete fix "recommendation" by zhangph12138@outlook.com via
  fetchmail-devel@.  The fix suggested in that AI report was wrong, and
  would happily crash a few lines later again.  The fix deployed calculates
  the buffer size of "workarea" variables based on the sizeof() of constituent
  components.

## BUGFIX
* Robustness: If RPA is enabled at compile time and POP3 is in use,
  do not barf if @compuserve.com is in the remote site's username (what you'd
  pass as --user, or user in the rcfile) and the remote site either does not
  support an "AUTH" command without parameters (normally, one is required, but
  some servers such as jpop and Cyrus allow AUTH to request the list of
  supported authentication types as an extension; the standard way would be
  a "CAPA" request instead), but try other authentication methods.
  Found by code auditing in response to a bug report against rpa.c.
  Note that enabling RPA is discouraged because it is based on the weak
  MD5 crypto algorithm.

-------------------------------------------------------------------------------
fetchmail-6.6.4 (released 2026-05-08, 32432 LoC):

## BUGFIX
* The IMAP client will now properly quote the folder name given with the
  moveto rcfile option, or --moveto command-line option.
  Report and bugfix contributed by Corben Dallas.

## BUILD IMPROVEMENTS
* meson-based builds with wolfSSL should now also work when meson finds
  the wolfssl package through cmake, instead of pkgconfig. This is unsupported
  and depends on internal set(_wolfssl_includedir "...") in wolfSSL's
  lib/cmake/*.cmake files, and works as of wolfSSL 5.9.1.
  The supported way to build fetchmail with wolfSSL with meson is
  to make sure that wolfSSL is found with pkgconfig, as in (change /path/to!)
  meson setup --pkg-config-path /path/to/wolfssl/lib/pkgconfig

## EXPERIMENTAL CHANGES - these are not documented anywhere else, only here:
* fetchmail supports AWS-LC 1.71 or newer, since its relicensing to
  the Apache license v2.0.  Note this requires you to distribute fetchmail
  under terms of the GPLv3 because the GPLv2 is claimed incompatible
  with Apache license (this is no different for OpenSSL 3 or newer,
  or the one wolfSSL version that was GPLv3 licensed).
* fetchmail supports a FETCHMAIL_SSL_SECLEVEL environment variable
  (since 6.5.0, except when using AWS-LC where it is silently ignored),
  which can be used to override the OpenSSL security level.
  Fetchmail by default raises the security level to 2 if lower.
  This variable can be used to lower it.
  Use with extreme caution. Note that levels 3 or higher will frequently cause
  incompabilities with servers because server-side data sizes are often too low.
  Valid range: 0 to 5 for OpenSSL 1.1.1 and 3.0.
* fetchmail supports a FETCHMAIL_SSL_CIPHERS environment variable
  (since 6.5.0) that sets the cipher string (through two different OpenSSL
  functions) for SSL and TLS versions up to TLSv1.2.
  If setting the ciphers fails, fetchmail will not connect.
  If not given, defaults to "HIGH:MEDIUM:+RC4:@STRENGTH:!aNULL" - note
  that +RC4 is supposed to move the RC4 to the end of the list, not add it.
* fetchmail supports a FETCHMAIL_TLS13_CIPHERSUITES environment variable
  (since 6.5.0) that sets the ciphersuites (a colon-separated list,
  without + ! -) for TLSv1.3. If not given, defaults to the SSL library's
  built-in list. If setting the ciphersuites fails, fetchmail refuses to
  connect.
* NOTE the features above are simplistic. For instance, even though you
  configure --sslproto tls1.3, a failure to set tls1.2 ciphers could cause
  a connection abort.

-------------------------------------------------------------------------------
fetchmail-6.6.3 (released 2026-04-01, 32388 LoC):

## COMPATIBILITY:
* fetchmail can now be built with OpenSSL 4.0.0 (tested as of -beta1).

-------------------------------------------------------------------------------
fetchmail-6.6.2 (released 2025-12-09, 32386 LoC):

## BUGFIX:
* fetchmail 6.6.0 and 6.6.1 could not be configured without SSL, it would break
  compiling sink.c.  Fix compilation.  Report by Toralf Förster, analysis and
  different patch suggested by Holger Hoffstätte, fixes #86.
  https://bugs.gentoo.org/967258 and
  https://gitlab.com/fetchmail/fetchmail/-/issues/86

-------------------------------------------------------------------------------
fetchmail-6.6.1 (released 2025-11-12, 32381 LoC):

## TRANSLATIONS were updated by these fine people (randomized order):
* sr:    Мирослав Николић [Serbian]
* es:    Cristian Othón Martínez Vera [Spanish]

-------------------------------------------------------------------------------
fetchmail-6.6.0 (released 2025-10-27, 32381 LoC):

## FEATURE:
* SMTP TLS and STARTTLS support. By default, this works opportunistically,
  attempting to set up a TLS connection to the smtphost if it understands EHLO
  and offers STARTTLS, but will not enforce peer certificate validity for
  compatibility, esp. because "localhost" (the default SMTP host) usually
  isn't listed in the X.509 certificates.
    Behavior can be tweaked by adding /notls (cleartext connection), /tls
  (TLS-wrapped connection, negotiating TLS before conversing otherwise),
  or /starttls (requiring EHLO to offer STARTTLS, requesting the latter and
  requiring the server certificate to validate) to the SMTP host's name.
    Also, you can add /tlsproto=... where ... accepts the same parameters
  as the --sslproto option, which see.
  Ports, if not specified, default to 25 for opportunistic and /notls modes,
  465 for /tls and 587 for /starttls, but can be overridden either by giving,
  say /25 or /smtp for /starttls.

## TRANSLATIONS were updated by these fine people (randomized order):
* it:    Luca Vercelli [Italian]
* pl:    Jakub Bogusz [Polish]
* fr:    Frédéric Marchal [French]
* sv:    Göran Uddeborg [Swedish]
* sq:    Besnik Bleta [Albanian]
* ro:    Remus-Gabriel Chelu [Romanian]
* ja:    Takeshi Hamasaki [Japanese]
* de:    Matthias Andree [German]
* cs:    Petr Pisar [Czech]
* eo:    Keith Bowes [Esperanto]

-------------------------------------------------------------------------------
fetchmail-6.5.7 (released 2025-10-18, 32215 LoC):

## BUGFIXES:
* When authenticating to an SMTP server, the AUTH LOGIN method (which didn't
  become a proposed standard, and is only the third method fetchmail would try,
  if CRAM-MD5 and PLAIN weren't offered) required that the server returned
  a 334 code followed by a blank and by a decodable base64 challenge we ignored
  anyways.  This is in line with RFC 4952.
    However, to improve compatibility, fetchmail now accepts anything that
  starts with "334 " and disregards the remainder of the line.
  At the same time, AUTH LOGIN was deprecated. AUTH PLAIN should be available
  everywhere AUTH LOGIN is, and is specified in IETF RFC 4616.
* When authenticating to an SMTP server, i. e. esmtpname/esmtppassword are
  defined, check for errors, and skip servers that do not understand EHLO,
  because we cannot negotiate supported authentication schemes with them.
  This should avoid attempting to send a lot of messages and see them rejected.
* When authenticating to an SMTP server, do not send client abort "*" when
  we receive any other server reply but 334.
* Extend 6.5.6's RFC-5321 address-literal fix to MAIL FROM. This might
  apply when we only have a server's IP address and need to quality
  addresses without domain. Fixes Debian Bug#1080025.
* SMTP AUTH can now look up passwords from the .netrc file - for that,
  fetchmail's esmtpname setting must match the login for the given host in
  .netrc. Fixes Debian Bug#1056651 by Ticker Berkin.
* Improve the GSSAPI (Kerberos V) build, which was pretty hard to get working.
  This was improved. Recommendation:
  - For autoconf builds (./configure), be sure to have the desired krb5-config
  executable early on $PATH before running ./configure.
  - For meson builds, be sure to list the path to your krb5-gssapi.pc file on
  PKG_CONFIG_PATH.  (meson will fall back to krb5-config, so if that's on PATH,
  that should also work.)

## TRANSLATION UPDATES were contributed by these fine people - thank you!
* The Italian translation is back - it had been missing from earlier 6.5.X
  since it had fallen too far behind with the last update in 2010.
* cs:    Petr Pisar [Czech]
* eo:    Keith Bowes [Esperanto]
* es:    Cristian Othón Martínez Vera [Spanish]
* fr:    Frédéric Marchal [French]
* it:    Luca Vercelli [Italian]
* ja:    Takeshi Hamasaki [Japanese]
* pl:    Jakub Bogusz [Polish]
* ro:    Remus-Gabriel Chelu [Romanian]
* sq:    Besnik Bleta [Albanian]
* sv:    Göran Uddeborg [Swedish]

-------------------------------------------------------------------------------
fetchmail-6.5.6 (released 2025-10-03, 31795 LoC):

## SECURITY BUGFIX:
* fetchmail-SA-2025-01.txt: CVE-2025-61962
  An SMTP server advertising EHLO and AUTH, and if fetchmail is configured to
  authenticate (esmtpname and esmtppassword given and non-empty), the server
  might crash fetchmail by sending a "334" response without further blank to
  fetchmail's AUTH request. This is in violation of applicable RFC-4952 though.
    Fetchmail now detects this situation and reports it separately as
  malformed server reply.
    Fetchmail 6.5.6 has been released without waiting for translation updates
  or CVE identifier, these will be provided in followup releases.

## BUGFIXES:
* RFC-5321: When the --smtpaddress, --smtphost, --smtpname, -D or -S argument
  is an numeric address literal such as 192.0.2.2 or 2001:0DB8::4321, properly
  format that as such in the SMTP RCPT command as user@[192.0.2.2] or
  user@[IPv6:2001:0DB8::4321].
* When printing output on the console while fetching mail, do not intersperse
  another copy of our program name and date in the middle of a log line.

  Workaround for older versions: --logfile /dev/tty  (might also use
  --logfile /dev/stderr) - but note this changes buffering behavior and may
  output to appear later and without ticker marks.
* A few low-priority memory leaks in the command-line options parser were
  fixed. Since this parser runs only once, leaks are harmless.
* Some minor code cleanups and robustness fixes were made, and we should
  see fewer compiler warnings as a result.

## CHANGES:
* Given the slow update schedules of some distributions, already add code
  that checks if time_t() is good beyond the year 2038,
  meaning time_t is either unsigned (which would last until 2106) or
  64 bits wide.  If the system isn't safe, warn on every launch of fetchmail
  beginning 2028-01-01 at 00:00 GMT so users have 10 years to plan.
  Fetchmail will also print a warning if time(time_t *t) overflows.

-------------------------------------------------------------------------------
fetchmail-6.5.5 (released 2025-09-24, 31528 LoC):

## LICENSING CHANGE OF WOLFSSL:
* Note that wolfSSL 5.8.2 switched license from GPLv2 to GPLv3, so if
  a distribution links fetchmail against wolfSSL, this implies the use
  of the "or-any-later-version" clause of the GPLv2-or-later licensed material
  in fetchmail, and the combined work can also only ship as GPLv3.
  This may or may not apply to later versions of wolfSSL - be sure to check!
  
## BUGFIXES:
==-- note that these comprise C23 compatibility fixes (GCC 15) --==
* Support t.operation when the running user is different from the one
  mentioned in the $USER variable.  Fix courtesy of Corey Halpin.
* The kerberos*_auth() functions for v4 and v5 have prototypes now,
  so they can be compiled by the most modern C compilers.
* AC_TYPE_* type-checking macros seem unnecessary, strip them, also from
  config.h.meson which would not fill them from build.meson. We expect
  the operating system to provide us pid_t, size_t, uint32_t.
* Our res_search() autoconf check was broken on compilers adhering to newer
  standards (C23), for instance GCC 15, disabling several DNS-based features
  in autotools-based builds, but not meson-based builds.
  Strip the bogus "extern int res_search();" declaration without prototype,
  we would need to have the prototype from the system either way.

## IMPORTANT CHANGE:
* Fetchmail is now more careful to actually clear password and like buffers
  in memory, so that is less likely that other processes could access them
  should they happen to access similar memory regions after fetchmail's exit.
    Fetchmail now uses memset_explicit(), explicit_bzero(), or its own
  explicit_bzero() implementation to clear memory buffers that contain
  passwords or like secrets, or their base64 equivalents, and also buffers
  that it uses to visualize such strings, instead of just using memset().
    The motivating reason is that a plain memset() that does not have
  /observable/ effects, i. e. when we do not read from the buffer or
  transfer it, can be removed by the compiler's optimizer in the so-called
  dead store elimination, voiding our attempt to clear the buffer contents
  before releasing it to the heap.
    The named alternative functions are not being optimized away.

## WORKAROUND:
* IMAP: Recognize SASL_IR advertisement of Cyrus IMAP 3.10.0...3.12.? as
  synonymous to SASL-IR per RFC4959.  Upstream bug reported at
  https://github.com/cyrusimap/cyrus-imapd/issues/5481 - and it was
  quickly fixed in all their supported branches by patch releases.

## CHANGES:
* Several documentation tweaks.
* As long as SOURCE_DATE_EPOCH is set, the source tarball build may
  be reproducible now.  Tested on Fedora 42.
* The Japanese translation [ja] has been updated by Takeshi Hamasaki.
* The Makefile should be compatible across a wider set of make implementations,
  beyond GNU make.

-------------------------------------------------------------------------------
fetchmail-6.5.4 (released 2025-06-17, 31208 LoC):

## BUGFIXES:
* socket: avoid crash when writing to a socket without SSL/TLS fails.
  Reported by Andrea Venturoli via mailing list, fixes #71.
* wolfSSL support: avoid fetchmail.c compilation failure in certain
  configurations of wolfSSL (for instance, on FreeBSD's wolfssl-5.8.0_1
  package), OpenSSL_version enables a newer 1.1.x compat API that passes its
  argument to a wolfSSL API, with OPENSSL_DIR and OPENSSL_ENGINES_DIR, causing
  related compiler failures.
  See <https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=287435>.

-------------------------------------------------------------------------------
fetchmail-6.5.3 (released 2025-06-10, 31204 LoC):

## BUGFIXES:
* IMAP: Reinstate workaround for missing IDLE support if --idle is requested.
  This had been a long-standing feature but got broken in fetchmail 6.4.22
  (commit 616e8c70).  Thanks to Lukáš Tesař for the detailed report including
  a Git bisect that identified this faulty commit.  Fixes Gitlab issue #69.
* IMAP: Only print 'will idle after poll' if --idle is enabled
  and either offered by the server, or forced through --forceidle.
  This fixes a regression introduced in fetchmail 6.4.22 (commit 616e8c70).

## TRANSLATIONS: fetchmail's translation was updated, courtesy of:
* es:    Cristian Othón Martínez Vera [Spanish]

-------------------------------------------------------------------------------
fetchmail-6.5.2 (released 2024-12-30, 31200 LoC):

## TRANSLATIONS: fetchmail's translations were updated, courtesy of:
* cs:    Petr Pisar [Czech]
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]

## CHANGES:
* Minor documentation consistency fixes (versions, dates).

-------------------------------------------------------------------------------
fetchmail-6.5.1 (released 2024-11-13, 31200 LoC):

## BUG AND PORTABILITY FIXES:
* Drop two wolfSSL compile-time checks that were for older 6.4 or for future
  7.0 releases and broke compilation with wolfSSL 5.7.4. 
  Fixes https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=282413#c4
* Use %p instead of non-portable %#p for one wolfSSL-related diagnostic message
  (FreeBSD defines %#p to be %p, on many other platforms it's undefined 
  behavior).
* Add regex_helper.c to list of files that contain translatable strings,
  which contains two strings we missed to translate.

## CHANGES:
* Simplify EVP_MD_fetch API detection ("like OpenSSL 3" vs. "like OpenSSL 1") 
  for version switch and base it on the claimed OpenSSL version of the crypto 
  SSL, which works for LibreSSL (claims OpenSSL 2) and wolfSSL alike.

## TRANSLATIONS: fetchmail's messages were translated by these fine people:
* sq:    Besnik Bleta [Albanian]
* es:    Cristian Othón Martínez Vera [Spanish]
* ro:    Remus-Gabriel Chelu [Romanian]
* fr:    Frédéric Marchal [French]
* pl:    Jakub Bogusz [Polish]
* sv:    Göran Uddeborg [Swedish]
* ja:    Takeshi Hamasaki [Japanese]
* eo:    Keith Bowes [Esperanto]

-------------------------------------------------------------------------------
fetchmail-6.5.0 (released 2024-10-29, 31200 LoC):

## SECURITY FIX:
* .netrc now may not have more than 0700 permission if it contains passwords,
  else fetchmail will warn and ignore the file.

## REMOVED FEATURES
* fetchmail no longer supports using an MDA as SMTP fallback. This is required 
  to make deliveries consistent.
  The --enable-fallback configure option is gone.
* fetchmail no longer supports SSLv3. --sslproto ssl3 and ssl3+ options have
  been removed and behave as though "--sslproto auto" had been given.

## INCOMPATIBLE CHANGES
* fetchmail by default only negotiates TLS v1.2 or higher. (RFC-7525)
* fetchmail can auto-negotiate TLS v1.1 through the --sslproto tls1.1+ option.
* fetchmail can auto-negotiate TLS v1.0 through the --sslproto tls1+ option.
* fetchmailconf now requires Python 3.7.0 or newer.
* fetchmail, with --logfile, now logs time stamps into the file, in localtime
  and in the format "Jun 20 23:45:01 fetchmail: ". It will be localized through
  the environment variables LC_TIME (or LC_ALL) and TZ.
  Contributed by Holger Hoffstätte.
* fetchmail sets the OPENSSL security level to 2 by default.
  Override is possible from an environment variable,
  see EXPERIMENTAL CHANGES below.
* The ca, da, en_GB, id, it, nl, ru, zh_CN translations have been disabled,
  they are too far behind.

## CHANGED REQUIREMENTS
* fetchmail 6.5.0 is written in C99 and requires a SUSv3 (Single Unix
  Specification v3, a superset of POSIX.1-2001 aka. IEEE Std 1003.1-2001 with
  XSI extension) compliant system.

  In particular, older fetchmail versions had workarounds or replacement code
  for several functions standardized in the Single Unix Specification v3, these
  have been removed. Hence:
  - The trio/ library has been removed from the distribution.
  - The libesmtp/getaddrinfo.? library has been removed from the distribution.
  - The KAME/getnameinfo.c file has been removed from the distribution.

* fetchmail 6.5.0 requires a TLSv1.3-capable version of OpenSSL or wolfSSL,
  at a minimum OpenSSL v3.0.9 or wolfSSL v5.7.2.

## TRANSLATIONS: fetchmail's messages were translated by these fine people:
* cs:    Petr Pisar [Czech]
* eo:    Keith Bowes [Esperanto]
* es:    Cristian Othón Martínez Vera [Spanish]
* fr:    Frédéric Marchal [French]
* ja:    Takeshi Hamasaki [Japanese]
* ro:    Remus-Gabriel Chelu [Romanian]
* sv:    Göran Uddeborg [Swedish]
* sq:    Besnik Bleta [Albanian]
* pl:    Jakub Bogusz [Polish]

## BUG FIXES
* fetchmail can now report mailbox sizes of 2^31 octets and beyond (2 GibiB).
  This required C99 support (for the long long type).
  Fixes Debian Bug#873668, reported by Andreas Schmidt.
* fetchmail now defines its OpenSSL API level to 3.0.0 so as to expose the
  3.0.0 APIs from OpenSSL.
* The .netrc parser no longer permits "machine" after "default".
* Add manpage info on the .netrc syntax, as ftp(1) is not standardized and
  may not be installed. Fixes Launchpad Bug #1976361 reported by Bill Yikes.
* Received: lines now return GMT time if the tzoffset cannot be represented
  as whole minutes. Reported by @rriddicc via Gitlab #49.
* If fetchmail was running localized, generated an error e-mail message locally,
  and if the selected translation would require the Subject: line to wrap
  inside an RFC-2047 encoded word (=?UTF-8?Q?...?=), the wrapped encoded-word
  was not indented, thus not marked as a continuation line.
* SSL error handling was improved, fetchmail now consistently clears the
  thread/SSL error queue before SSL I/O operations and checks SSL_get_error
  afterwards.  The SSL_connect() error handling has been revised to log more
  consistently.

## CHANGES
* When fetchmail attempts to log out from an IMAP4 server and the server messes
  up its responses (it is supposed to send an untagged * BYE and a tagged
  A4711 OK) and sends a tagged A4711 BYE response, tolerate that, rather than
  reporting a protocol error. We don't intend to chat any more so the protocol
  violation is harmless, and we know the server cannot send more untagged
  status responses.
  Analysis and fix courtesy of Maciej S. Szmigiero, GitLab merge request !20.
* The configure script now spends more effort for getting --with-ssl right, by
  running pkg-config in the right environment, and using the AC_LIB_LINKFLAGS
  macro to obtain run-time library path setting flags.
* For typical POP3/IMAP ports 110, 143, 993, 995, if port and --ssl option
  do not match, emit a warning and continue. Closes Gitlab #31.
* There is now a --idletimeout feature contributed by Eric Durand, to
  permit setting a shorter timeout for the --idle option, because many
  servers violate the protocol (requiring 30 minutes) and hang up sooner than
  the 28 minutes fetchmail waits before refreshing IDLE.
  GitLab merge request !35.
* There is now a --forceidle feature to force idle mode even if not advertised
  in the server capabilities. This is a dangerous option, use it carefully.
  Courtesy of Eric Durand, GitLab merge request !39.
* There is now a --moveto feature (only feasible in IMAP) that, instead of
  flushing mail, moves it to a user-specified folder. This is to assist with
  archiving, or when providers (G...) break the IMAP model.
  Courteously provided by Damjan Jovanovic.
* rcfile parsing errors are now reported in more detail, and with -vv mode,
  also lead to a non-importable Python dump of what was obtained, for debugging.
* fetchmail's --auth option ssh was renamed to implicit, to make clear that it
  does *NOT* imply any particular type or features of the --plugin.  --auth ssh
  will be understood for a while for compatibility but fetchmail will report it
  as implicit.
* fetchmail no longer warns about port/service mismatches with/without ssl
  option when a "plugin" is in use because fetchmail cannot know whether the
  plugin talks SSL or STARTTLS/STLS. Fixes Debian Bug#1076604.
* fetchmail re-executes itself if the .netrc file's modification change
  is found to be newer at the beginning of a new run.
* fetchmail can now use other digest algorithms than MD5 for the
  --sslfingerprint option. To use, specify the algorithm's name in
  curly braces as prefix in the finger print, say,
  --sslfingerprint '{SHA256}00:01:[...]:1F'. This will also switch the
  algorithm for printing. All algorithms supported by the TLS/SSL library
  can be specified. Fixes Gitlab issue #19, Debian Bug#700266.

## EXPERIMENTAL CHANGES - these are not documented anywhere else, only here:
(part of this section may float upwards)
* fetchmail can be built with meson 1.30 or newer <https://mesonbuild.com/>.
  fetchmail is not currently written in a way that supports unity
  (amalgamated) builds.

================================================================================
fetchmail-6.4.39 (released 2024-07-20, 31729 LoC):

# BUG FIXES:
* When a server offers STARTTLS although the connection is already wrapped
  in TLS, fetchmail would issue a bogus "WARNING: server offered STARTTLS but
  sslproto '' given." (or STLS for POP3).  In situations where we wrap the
  connection in TLS, suppress the warning. Reported by Mike Pope.

* If fetchmail was running localized, generate an error e-mail message locally,
  and if the selected translation would require the Subject: line to wrap
  inside an RFC-2047 encoded word (=?UTF-8?Q?...?=), the wrapped encoded-word
  was not indented, thus not marked as a continuation line.

--------------------------------------------------------------------------------
fetchmail-6.4.38 (released 2024-01-31, 31720 LoC):

# BREAKING CHANGES:
* Tighten OpenSSL and wolfSSL version requirements again. See README.SSL.
  Distributors providing older versions that they backport security fixes for
  may want to patch socket.c but remember to redirect support to your
  distribution's support channels.
  The fetchmail maintainer only supports functionally unmodified builds with
  publicly available SSL/TLS library versions.
  fetchmail will refuse to build against OpenSSL 1.0.2 older than 1.0.2u,
  or wolfSSL older than 5.6.2. It will warn about OpenSSL older than 3.0.9,
  or between 3.1.0 and 3.1.4, or wolfSSL older than 5.6.6.

# TRANSLATIONS: language translations were updated by these fine people:
(in reverse alphabetical order of language codes):
* ru:    Kirill Isakov [Russian]
* eo:    Keith Bowes [Esperanto]

--------------------------------------------------------------------------------
fetchmail-6.4.37 (released 2023-02-26, 31710 LoC):

# TRANSLATIONS: language translations were updated by this fine person:
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]

--------------------------------------------------------------------------------
fetchmail-6.4.36 (released 2023-01-28, 31710 LoC):

# TRANSLATIONS: language translations were updated by these fine people:
(in alphabetical order of language codes):
* cs:    Petr Pisar [Czech]
* es:    Cristian Othón Martínez Vera [Spanish]
* fr:    Frédéric Marchal [French]
* ja:    Takeshi Hamasaki [Japanese]
* pl:    Jakub Bogusz [Polish]
* ro:    Remus-Gabriel Chelu [Romanian]
* sq:    Besnik Bleta [Albanian]
* sv:    Göran Uddeborg [Swedish]

--------------------------------------------------------------------------------
fetchmail-6.4.35 (released 2023-01-04, 31707 LoC):

# BREAKING CHANGES:
* Fetchmail now warns about OpenSSL before 1.1.1s or 3.0.7,
  and rejects wolfSSL older than 5.5.1.

# TRANSLATIONS: language translations were updated by these fine people:
(in reverse alphabetical order of language codes so as not to prefer people):
* sv:    Göran Uddeborg [Swedish]
* eo:    Keith Bowes [Esperanto]

--------------------------------------------------------------------------------
fetchmail-6.4.34 (released 2022-10-15, 31701 LoC):

# CRITICAL BUG FIXES:
* When an SMTP receiver refuses delivery, a message would be deleted from
  the mail store in spite of a softbounce option that is enabled.
  Bug report, analysis and patch by Horváth Zsolt. Gitlab, fixes #50.

# BUILD NOTE:
* If you are reusing config.cache from prior builds, this may cause
  issues with finding Python or some libraries.  In case of trouble,
  remove config.cache and retry.

# TRANSLATIONS: language translations were updated by this fine person:
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]

--------------------------------------------------------------------------------
fetchmail-6.4.33 (released 2022-08-27, 31696 LoC):

# TRANSLATIONS: language translations were updated by this fine person:
* fr:    Frédéric Marchal [French]

# CONTRIBUTED SCRIPT CHANGES:
* contrib/fetchsetup improvements by Matěj Cepl
* contrib/runfetchmail improvements by Matěj Cepl

--------------------------------------------------------------------------------
fetchmail-6.4.32 (released 2022-07-30, 31696 LoC):

# FIXES:
* Use configure to find rst2html, some systems install it only with .py suffix,
  others only without, and some install both.
* Update README.maintainer

# TRANSLATIONS: language translations were updated by these fine people:
(in alphabetical order of language codes so as not to prefer people):
* cs:    Petr Pisar [Czech]
* es:    Cristian Othón Martínez Vera [Spanish]
* ja:    Takeshi Hamasaki [Japanese]
* pl:    Jakub Bogusz [Polish]
* ro:    Remus-Gabriel Chelu [Romanian]
* sq:    Besnik Bleta [Albanian]
* sv:    Göran Uddeborg [Swedish]

--------------------------------------------------------------------------------
fetchmail-6.4.31 (released 2022-07-16, 31694 LoC):

# BUG FIXES:
* Try to fix ./configure --with-ssl=... for systems that have multiple OpenSSL
  versions installed.  Issues reported by Dennis Putnam.
* The netrc parser now reports its errors to syslog or logfile when appropriate,
  previously it would always log to stderr.
* Add error checking to .netrc parser.

# CHANGES:
* manpage: use .UR/.UE macros instead of .URL for URIs.
* manpage: fix contractions. Found with FreeBSD's igor tool.
* manpage: HTML now built with pandoc -> python-docutils
  (manServer.pl was dropped)

--------------------------------------------------------------------------------
fetchmail-6.4.30 (released 2022-04-26, 31666 LoC):

# BREAKING CHANGES:
* Bump wolfSSL minimum required version to 5.2.0 to pull in security fix.

# CHANGES:
* Using OpenSSL 1.* before 1.1.1n elicits a compile-time warning.
* Using OpenSSL 3.* before 3.0.2  elicits a compile-time warning.
* configure.ac was tweaked in order to hopefully fix cross-compilation issues
  report, and different patch suggested, by Fabrice Fontaine,
  https://gitlab.com/fetchmail/fetchmail/-/merge_requests/42

# TRANSLATIONS: language translations were updated by this fine person:
* ro:    Remus-Gabriel Chelu [Romanian]

--------------------------------------------------------------------------------
fetchmail-6.4.29 (released 2022-03-20, 31661 LoC):

# TRANSLATIONS: language translations were updated by this fine person:
* vi:    Trần Ngọc Quân [Vietnamese]

--------------------------------------------------------------------------------
fetchmail-6.4.28 (released 2022-03-05, 31661 LoC):

# DOCUMENTATION:
* Fix a typo in the manual page, courtesy of Jeremy Petch.

# TRANSLATIONS: language translations were updated by this fine person:
* es:    Cristian Othón Martínez Vera [Spanish]

--------------------------------------------------------------------------------
fetchmail-6.4.27 (released 2022-01-26, 31661 LoC):

# BREAKING CHANGES:
* Bump wolfSSL minimum required version to 5.1.1 to pull in security fix.

# TRANSLATIONS: language translations were updated by this fine person:
* ro:    Remus-Gabriel Chelu [Romanian]

--------------------------------------------------------------------------------
fetchmail-6.4.26 (released 2021-12-26, 31661 LoC):

# FIXES:
* When using wolfSSL 5.0.0, work around a bug that appears to hit wolfSSL when
  receiving handshake records while still in SSL_peek(). Workaround is to read
  1 byte and cache it, then call SSL_peek() again.
  This affects only some servers. https://github.com/wolfSSL/wolfssl/issues/4593

# TRANSLATIONS: language translations were updated by this fine person:
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]

--------------------------------------------------------------------------------
fetchmail-6.4.25 (released 2021-12-10, 31653 LoC):

# BREAKING CHANGES:
* Since distributions continue patching for LibreSSL use, which cannot be
  linked legally, block out LibreSSL in configure.ac and socket.c, and
  refer to COPYING, unless on OpenBSD (which ships it in the base system).
  OpenSSL and wolfSSL 5 can be used.  SSL-related documentation was updated, do 
  re-read COPYING, INSTALL, README, README.packaging, README.SSL.
* Bump OpenSSL version requirement to 1.0.2f in order to safely remove
  the obsolete OpenSSL flag SSL_OP_SINGLE_DH_USE. This blocks out 1.0.2e and 
  older 1.0.2 versions. 1.0.2f was a security fix release, and 1.0.2u is 
  publicly available from https://www.openssl.org/source/old/1.0.2/
* Some of the configure.ac fiddling MIGHT have broken cross-compilation
  again. The maintainer does not test cross-compiling fetchmail; if you
  have difficulties, try setting PKG_CONFIG_LIBDIR to the pkg-config path
  containing your target/host libraries, or see if --with-ssl-prefix or 
  --with-wolfssl-prefix, or overriding LDFLAGS/LIBS/CPPFLAGS, can help.
  Feedback solicited on compliant systems that are before end-of-life.

# BUG FIXES:
* 6.4.24's workaround for OpenSSL 1.0.2's X509_V_FLAG_TRUSTED_FIRST flag
  contained a typo and would not kick in properly.
* Library and/or rpath setting from configure.ac was fixed.

# ADDITIONS:
* Added an example systemd unit file and instructions to contrib/systemd/
  which runs fetchmail as a daemon with 5-minute poll intervals.
  Courteously contributed by Barak A. Pearlmutter, Debian Bug#981464.
* fetchmail can now be used with wolfSSL 5's OpenSSL compatibility layer,
  see INSTALL and README.SSL. This is considered experimental.
  Feedback solicited.

# CHANGES:
* The getstats.py dist-tool now counts lines of .ac and .am files.
* ./configure --with-ssl now supports pkg-config module names, too. See INSTALL.

# TRANSLATIONS: language translations were updated by these fine people:
(in reverse alphabetical order of language codes so as not to prefer people):
* sv:    Göran Uddeborg [Swedish]
* sq:    Besnik Bleta [Albanian]
* pl:    Jakub Bogusz [Polish]
* ja:    Takeshi Hamasaki [Japanese]
* fr:    Frédéric Marchal [French]
* eo:    Keith Bowes [Esperanto]
* cs:    Petr Pisar [Czech]

# CREDITS:
* Thanks to Corey Halpin for testing release candidates.

--------------------------------------------------------------------------------
fetchmail-6.4.24 (released 2021-11-20, 30218 LoC):

# OPENSSL AND LICENSING NOTE:
> see fetchmail-6.4.22 below, and the file COPYING.

  Note that distribution of packages linked with LibreSSL is not feasible
  due to a missing GPLv2 clause 2(b) exception.

# COMPATIBILITY:
* Bison 3.8 dropped yytoknum altogether, breaking compilation due to a
  warning workaround. Remove the cast of yytoknum to void.  This may cause
  a compiler warning to reappear with older Bison versions.
* OpenSSL 1.0.2: Workaround for systems that keep the expired DST Root CA X3 
  certificate in its trust store because OpenSSL by default prefers the 
  untrusted certificate and fails.  Fetchmail now sets the 
  X509_V_FLAG_TRUSTED_FIRST flag (on OpenSSL 1.0.2 only).
  This is workaround #2 from the OpenSSL Blog.  For details, see both:
  https://www.openssl.org/blog/blog/2021/09/13/LetsEncryptRootCertExpire/
  https://letsencrypt.org/docs/dst-root-ca-x3-expiration-september-2021/

  NOTE: OpenSSL 1.0.2 is end of life, it is assumed that the OpenSSL library
  is kept up to date by a distributor or via OpenSSL support contract.
  Where this is not the case, please upgrade to a supported OpenSSL version.

# DOCUMENTATION:
* The manual page was revised after re-checking with mandoc -Tlint, aspell,
  igor. Some more revisions were made for clarity.

# TRANSLATIONS: language translations were updated by these fine people:
* sv:    Göran Uddeborg [Swedish]
* pl:    Jakub Bogusz [Polish]
* fr:    Frédéric Marchal [French]
* cs:    Petr Pisar [Czech]
* eo:    Keith Bowes [Esperanto]
* ja:    Takeshi Hamasaki [Japanese]

--------------------------------------------------------------------------------
fetchmail-6.4.23 (released 2021-10-31, 30206 LoC):

# USABILITY:
* For common ssh-based IMAP PREAUTH setups (i. e. those that use a plugin
  - no matter its contents - and that set auth ssh), change the STARTTLS 
  error message to suggest sslproto '' instead.
  This is a commonly reported issue after the CVE-2021-39272 fix in 6.4.22.
  Fixes Redhat Bugzilla 2008160. Fixes GitLab #39.

# TRANSLATIONS: language translations were updated by these fine people:
* ja:    Takeshi Hamasaki [Japanese]
* sr:	 Мирослав Николић (Miroslav Nikolić) [Serbian]

--------------------------------------------------------------------------------
fetchmail-6.4.22 (released 2021-09-13, 30201 LoC):

# OPENSSL AND LICENSING NOTE:
* fetchmail 6.4.22 is compatible with OpenSSL 1.1.1 and 3.0.0.
  OpenSSL's licensing changed between these releases from dual OpenSSL/SSLeay 
  license to Apache License v2.0, which is considered incompatible with GPL v2 
  by the FSF.  For implications and details, see the file COPYING.

# SECURITY FIXES:
* CVE-2021-39272: fetchmail-SA-2021-02: On IMAP connections, without --ssl and 
  with nonempty --sslproto, meaning that fetchmail is to enforce TLS, and when 
  the server or an attacker sends a PREAUTH greeting, fetchmail used to continue 
  an unencrypted connection.  Now, log the error and abort the connection.
  --Recommendation for servers that support SSL/TLS-wrapped or "implicit" mode on
  a dedicated port (default 993): use --ssl, or the ssl user option in an rcfile.
  --Reported by: Andrew C. Aitchison, based on the USENIX Security 21 paper "Why 
  TLS is better without STARTTLS - A Security Analysis of STARTTLS in the Email 
  Context" by Damian Poddebniak, Fabian Ising, Hanno Böck, and Sebastian 
  Schinzel.  The paper did not mention fetchmail.

* On IMAP and POP3 connections, --auth ssh no longer prevents STARTTLS 
  negotiation.
* On IMAP connections, fetchmail does not permit overriding a server-side 
  LOGINDISABLED with --auth password any more.
* On POP3 connections, the possibility for RPA authentication (by probing with 
  an AUTH command without arguments) no longer prevents STARTTLS negotiation.
* For POP3 connections, only attempt RPA if the authentication type is "any".

# BUG FIXES:
* On IMAP connections, when AUTHENTICATE EXTERNAL fails and we have received the 
  tagged (= final) response, do not send "*".
* On IMAP connections, AUTHENTICATE EXTERNAL without username will properly send 
  a "=" for protocol compliance.
* On IMAP connections, AUTHENTICATE EXTERNAL will now check if the server 
  advertised SASL-IR (RFC-4959) support and otherwise refuse (fetchmail <= 6.4 
  has not supported and does not support the separate challenge/response with 
  command continuation)
* On IMAP connections, when --auth external is requested but not advertised by 
  the server, log a proper error message.
* Fetchmail no longer crashes when attempting a connection with --plugin "" or 
  --plugout "".
* Fetchmail no longer leaks memory when processing the arguments of --plugin or 
  --plugout on connections.
* On POP3 connections, the CAPAbilities parser is now caseblind.
* Fix segfault on configurations with "defaults ... no envelope". Reported by  
  Bjørn Mork. Fixes Debian Bug#992400.  This is a regression in fetchmail 6.4.3
  and happened when plugging memory leaks, which did not account for that the 
  envelope parameter is special when set as "no envelope". The segfault happens
  in a constant strlen(-1), triggered by trusted local input => no vulnerability.
* Fix program abort (SIGABRT) with "internal error" when invalid sslproto is 
  given with OpenSSL 1.1.0 API compatible SSL implementations.

# CHANGES:
* IMAP: When fetchmail is in not-authenticated state and the server volunteers 
  CAPABILITY information, use it and do not re-probe. (After STARTTLS, fetchmail 
  must and will re-probe explicitly.)
* For typical POP3/IMAP ports 110, 143, 993, 995, if port and --ssl option
  do not match, emit a warning and continue. Closes Gitlab #31.
  (cherry-picked from 6.5 beta branch "legacy_6x")
* fetchmail.man and README.SSL were updated in line with RFC-8314/8996/8997
  recommendations to prefer Implicit TLS (--ssl/ssl) and TLS v1.2 or newer,
  placing --sslproto tls1.2+ more prominently.
  The defaults shall not change between 6.4.X releases for compatibility.

# TRANSLATIONS: language translations were updated by these fine people:
* sq:    Besnik Bleta [Albanian]
* cs:    Petr Pisar [Czech]
* eo:    Keith Bowes [Esperanto]
* fr:    Frédéric Marchal [French]
* pl:    Jakub Bogusz [Polish]
* sv:    Göran Uddeborg [Swedish]

# CREDITS:
* Thanks for testing the release candidates and bug reports to:
  Corey Halpin, Stefan Eßer.

--------------------------------------------------------------------------------
fetchmail-6.4.21 (released 2021-08-09, 30042 LoC):

# REGRESSION FIX:
* The new security fix in 6.4.20 for CVE-2021-36386 caused truncation of
  messages logged to buffered outputs, from --logfile and --syslog.

  This also caused lines in the logfile to run into one another because
  the fragment containing the '\n' line-end character was usually lost.

  Reason is that on all modern systems (with <stdarg.h> header and vsnprintf()
  interface), the length of log message fragments was added up twice, so
  that these ended too deep into a freshly allocated buffer, after the '\0'
  byte.  Unbuffered outputs flushed the fragments right away, which masked the
  bug.

  Reported by: Jürgen Edner, Erik Christiansen.

--------------------------------------------------------------------------------
fetchmail-6.4.20 (released 2021-07-28, 30042 LoC):

# SECURITY FIX:
* When a log message exceeds c. 2 kByte in size, for instance, with very long 
  header contents, and depending on verbosity option, fetchmail can crash or
  misreport each first log message that requires a buffer reallocation.
  fetchmail then reallocates memory and re-runs vsnprintf() without another 
  call to va_start(), so it reads garbage. The exact impact depends on 
  many factors around the compiler and operating system configurations used and 
  the implementation details of the stdarg.h interfaces of the two functions
  mentioned before. To fix CVE-2021-36386.

  Reported by Christian Herdtweck of Intra2net AG, Tübingen, Germany.

  He also offered a patch, which I could not take for fetchmail 6.4 because
  it required a C99 system and I'd promised earlier that 6.4 would remain
  compatible with C89 systems.
--------------------------------------------------------------------------------
fetchmail-6.4.19 (released 2021-04-24, 30026 LoC):

# CHANGE:
* fetchmailconf: properly catch and report option parsing errors

# BUG FIX:
* LMTP: do not try to validate the last component of a UNIX-domain LMTP socket 
  as though it were a TCP port.  Reported by Christoph Heitkamp, Gitlab issue #33.

# TRANSLATION UPDATE:
  This fine person has contributed an updated translation:
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]

--------------------------------------------------------------------------------
fetchmail-6.4.18 (released 2021-03-27, 30011 LoC):

# REGRESSION FIX:
* fetchmailconf: fetchmail 6.4.16 added --sslcertfile to the configuration dump,
  but fetchmailconf support was incomplete in Git 7349f124 and it could not
  parse sslcertfile, thus the user settings editor came up empty with console
  errors printed.  Fix configuration parser in fetchmailconf.

# ROBUSTNESS FIXES:
* fetchmailconf: do not require fetchmail for -V. do not require Tk (Tkinter)
  for -d option. This is to fail more gracefully on incomplete installs.
* TLS code: remove OPENSSL_NO_DEPRECATED macros to avoid portability issues
  with OpenSSL v3 - these are for development purposes, not production.
* TLS futureproofing: use SSL_use_PrivateKey_file instead of 
  SSL_use_RSAPrivateKey_file, the latter will be deprecated with OpenSSL v3,
  and the user's key file might be something else than RSA.

# TRANSLATION UPDATE:
  This fine person has contributed an updated translation:
* fi:    Lauri Nurmi [Finnish]

--------------------------------------------------------------------------------
fetchmail-6.4.17 (released 2021-03-07, 29998 LoC):

# BUG FIXES
* IMAP client: it used to leak memory for username and password when trying
  the LOGIN (password-based) authentication and encountered a timeout situation.
* dist-tools/getstats.py: also counts lines in *.py files, shown above.

# CHANGES
* fetchmail.man: now mentions that you may need to add --ssl when specifying
  a TLS-wrapped port.
* fetchmailconf: --version (-V) now prints the Python version in use.

# TRANSLATION UPDATE:
  This fine person has contributed an updated translation:
* ja:    Takeshi Hamasaki [Japanese]

--------------------------------------------------------------------------------
fetchmail-6.4.16 (released 2021-02-08, 27707 LoC):

# BUG FIXES
* fetchmail's --configdump, and fetchmailconf, lacked support for the
  sslcertfile option. --configdump support added by Earl Chew,
  Gitlab issue #25, merge request !28.
* fetchmail's manual page was never updated to reflect 6.2.5's change about the
  duplicate-killer code for multidrop mode, which read
  "* Dup-killer code now keys on an MD5 hash of the raw headers."
  ...instead of just the Message-ID. [commit 9dd8400, 2003-10-10 by esr]
  The manual page was now updated accordingly and documents
  historic behaviour:
  start to 5.0.7 no duplicate suppression;
  5.0.8 to 6.2.4 duplicate suppression only by Message-ID;
  6.2.5 to 6.4.X duplicate suppression by entire raw header.
  Manpage bug found by Julian Bane debugging "duplicate message" behaviour.
* ./configure no longer runs AC_LIB_LINKFLAGS (how to link) checks
  when called --without-ssl

# FEATURES
* fetchmail --version [fetchmail -V] now queries and prints the SSL/TLS
  library's "SSL default trusted certificate" file or directory (mind the word
  "default"), where the OpenSSL-compatible TLS implementation will look for
  trusted root, meaning certification authority (CA), certificates.
  NOTE 1: watch the output carefully if the line prints the defaults
  or the configured path (without "default").
  NOTE 2: SSL_CERT_DIR and SSL_CERT_FILE are documented environment variables
  for OpenSSL 1.1.1 to override the *default* locations (those compiled into
  OpenSSL or possibly in its configuration file).
  This was added when Gene Heskett was debugging his setup and the
  information "where does OpenSSL look" was missing.
* fetchmail --version now prints version of the OpenSSL library that
  it was compiled against, and that it is using at runtime, and also
  the OPENSSL_DIR and OPENSSL_ENGINES_DIR (if available).

# TRANSLATION UPDATES
  These fine people have contributed updated translations for fetchmail,
  in no particular order:
* sq:    Besnik Bleta [Albanian]
* eo:    Keith Bowes [Esperanto]
* cs:    Petr Pisar [Czech]
* pl:    Jakub Bogusz [Polish]
* sv:    Göran Uddeborg [Swedish]
* fr:    Frédéric Marchal [French]

---------------------------------------------------------------------------------
fetchmail-6.4.15 (released 2021-01-03, 27614 LoC):

# BUG FIXES
* Fix a typo in the manual page reported by David McKelvie.
* Fix cross-compilation with openssl, by Fabrice Fontaine. Merge request !23.
* Fix truncation of SMTP PLAIN AUTH with ^ in credentials, by Earl Chew.
  Gitlab issue #23, merge request !25.

-------------------------------------------------------------------------------
fetchmail-6.4.14 (released 2020-11-26, 27608 LoC):

# TRANSLATION UPDATES were made by these fine people:
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]

---------------------------------------------------------------------------------
fetchmail-6.4.13 (released 2020-10-25, 27608 LoC):

# BUG FIXES:
* Errors about lock file (= pidfile) creation could be lost in daemon 
  configurations (-d option, or set daemon) when using syslog. Now they are also 
  logged to syslog.  Found verifying a pidfile creation issue on 6.4.12 that was 
  previously reported by Alex Hall of Automatic Distributors.
* If the lock file cannot be removed (no write permission on directory), try
  to truncate it, and if that fails, report error.
* If the pidfile was non-default, fetchmail -q or --quit would malfunction and
  claim no other fetchmail were running, because it did not read the 
  configuration files or merge the command line options, thus it would look for 
  the PID in the wrong file.

# CHANGES:
* Lockfile (= pidfile) creation errors are now logged with filename and reason.

# TRANSLATION UPDATES were made by these fine people:
* cs:    Petr Pisar [Czech]
* ja:    Takeshi Hamasaki [Japanese]
* sq:    Besnik Bleta [Albanian]
* zh_CN: Boyuan Yang [Chinese (simplified)]
* sv:    Göran Uddeborg [Swedish]
* pl:    Jakub Bogusz [Polish]
* fr:    Frédéric Marchal [French]
* eo:    Keith Bowes [Esperanto]
* de:    [German - by current maintainer]

---------------------------------------------------------------------------------
fetchmail-6.4.12 (released 2020-09-04, 27596 LoC):

# BUG FIXES:
* The README file is now the one from Git again. The makerelease.pl script
  used to roll and upload the tarball sometimes clobbered the README file and
  replaced its contents by a part of the NEWS file.

---------------------------------------------------------------------------------
fetchmail-6.4.11 (released 2020-08-28, 27596 LoC):

# REGRESSION FIX:
* configure: fetchmail 6.4.9 and 6.4.10 would miss checking for TLS v1.2 and
  TLS v1.3 support if AC_LIB_LINKFLAGS came up with something such as
  /path/to/libssl.so, rather than -lssl. (For instance on FreeBSD)

---------------------------------------------------------------------------------
fetchmail-6.4.10 (released 2020-08-27, 27596 LoC):

# REGRESSION FIX:
* configure: fetchmail 6.4.9's configure was unable to pick up OpenSSL
  if it wasn't announced by pkg-config, for instance, on FreeBSD.

---------------------------------------------------------------------------------
fetchmail-6.4.9: (not announced by e-mail, withdrawn)

## DOCUMENTATION UPDATE:
* manpage: mention that the SSL/TLS certificate fingerprint uses an MD5 hash.

## CHANGES:
* configure: try to use AC_LIB_LINKFLAGS to obtain proper link flags for 
  libcrypto and libssl if pkg-config failed.
  This is an attempt to fix borderline issues when users building on systems 
  with obsolete OpenSSL try to use a local newer OpenSSL from a separate 
  directory.

## NEW TRANSLATION, with thanks to the translator:
* ro:    Florentina Mușat [Romanian]

---------------------------------------------------------------------------------
fetchmail-6.4.8 (released 2020-06-14, 27596 LoC):

## NEW TRANSLATION, with thanks to the translator:
* sr:    Мирослав Николић (Miroslav Nikolić) [Serbian]
- Sorry, this was missed earlier because my translation scripts did not properly
  report new translations.

---------------------------------------------------------------------------------
fetchmail-6.4.7 (released 2020-06-14, 27596 LoC):

## TRANSLATION UPDATE, with thanks to the translator:
* sv:    Göran Uddeborg [Swedish]

-------------------------------------------------------------------------------
fetchmail-6.4.6 (released 2020-05-29, 27596 LoC):

## TRANSLATION UPDATE, with thanks to the translator:
* eo:    Felipe Castro [Esperanto]

--------------------------------------------------------------------------------
fetchmail-6.4.5 (released 2020-05-07, 27596 LoC):

## REGRESSION FIX:
* fetchmail 6.4.0 and 6.4.1 changed the resolution of the home directory
  in a way that requires SUSv4 semantics of realpath(), which leads to
  'Cannot find absolute path for... directory' error messages followed by aborts
  on systems where realpath() follows strict SUSv2 semantics and returns
  EINVAL if the 2nd argument is NULL.

  On such systems, for instance, Solaris 10, fetchmail requires PATH_MAX to be
  defined, and will then work again.  Regression reported by David Hough.

  On systems that neither provide auto-allocation semantics for realpath(),
  nor PATH_MAX, fetchmail will print this error and abort. Such systems
  are unsupported, see README.

## CHANGES:
* Add a test program fm_realpath, and a t.realpath script, neither to be
  installed. These will test resolution of the current working directory.

## TRANSLATION UPDATES in reverse alphabetical order of language codes,
## with my thanks to the translators:
* zh_CN: Boyuan Yang [Chinese (simplified)]
* sv:    Göran Uddeborg [Swedish]
* sq:    Besnik Bleta [Albanian]
* pl:    Jakub Bogusz [Polish]
* ja:    Takeshi Hamasaki [Japanese]
* fr:    Frédéric Marchal [French]
* cs:    Petr Pisar [Czech]

--------------------------------------------------------------------------------
fetchmail-6.4.4 (released 2020-04-26, 27530 LoC):

## UPDATED TRANSLATIONS - WITH THANKS TO THE TRANSLATOR:
* ja:    Takeshi Hamasaki [Japanese]

--------------------------------------------------------------------------------
fetchmail-6.4.3 (released 2020-04-05, 27530 LoC):

## BUGFIXES:
* Plug memory leaks when parts of the configuration (defaults, rcfile, command 
  line) override one another.
* Merge esmtpname and esmtppassword defaults properly.
* fetchmail terminated the placeholder command string too late and included
  garbage from the heap at the end of the string. Workaround: don't use place-
  holders %h or %p in the --plugin string. Bug added in 6.4.0 when merging
  Gitlab merge request !5 in order to fix an input buffer overrun.
  Faulty commit 418cda65f752e367fa663fd13884a45fcbc39ddd.
  Reported by Stefan Thurner, Gitlab issue #16.
* Fetchmail now checks for errors when trying to read the .idfile,
  Gitlab issue #3.
* Fetchmail's error messages that reports that the defaults entry isn't the 
  first was made more precise. It could be misleading if there was a poll or
  skip statement before the defaults.

## CHANGES:
* Fetchmail documentation was updated to require OpenSSL 1.1.1.
  OpenSSL 1.0.2 reached End Of Life status at the end of the year 2019.
  Fetchmail will tolerate, but warn about, 1.0.2 for now on the assumption that 
  distributors backport security fixes as the need arises.
  Fetchmail will also warn if another SSL library that is API-compatible
  with OpenSSL lacks TLS v1.3 support.
* If the trust anchor is missing, fetchmail refers the user to README.SSL.

## INTERNAL CHANGES:
* The AC_DECLS(getenv) check was removed, its only user was broken and not 
  accounting for that AC_DECLS always defines HAVE_DECL_... to 0 or 1, so
  fetchmail never declared a missing getenv() symbol (it was testing with 
  #ifdef).  Remove the backup declaration. getenv is mandated by SUSv2 anyways.

## UPDATED TRANSLATIONS - WITH THANKS TO THE TRANSLATORS:
* sq:    Besnik Bleta [Albanian]
* zh_CN: Boyuan Yang [Chinese (simplified)]
* pl:    Jakub Bogusz [Polish]
* cs:    Petr Pisar [Czech]
* fr:    Frédéric Marchal [French]
* sv:    Göran Uddeborg [Swedish]
* eo:    Felipe Castro [Esperanto]

--------------------------------------------------------------------------------
fetchmail-6.4.2 (released 2020-02-14, 27473 LoC):

## BREAKING CHANGES:
* fetchmailconf now supports Python 3 and currently requires the "future" 
  package, see https://pypi.org/project/future/.
* fetchmailconf: The minimum supported version is now Python 2.7.13, but it is 
  recommended to use at least 2.7.16 (due to its massive SSL updates).
  Older Python versions may check SSL certificates not strictly enough,
  which may cause fetchmail to complain later, if the certificate verify fails.
* fetchmailconf now autoprobes SSL-wrapped connections (ports 993 and 995 for 
  IMAP and POP3) as well and by preference.
* fetchmailconf now defaults newly created users to "ssl" if either of the
  existing users sets ssl, or if the server has freshly been probed and
  found supporting ssl.
  There is a caveat: adding a user to an existing server without probing it
  again may skip adding ssl. (This does not prevent STARTTLS.)

## BUG FIXES:
* Fix three bugs in fetchmail.man (one unterminated string to .IP macro, one
  line that ran into a .PP macro, .TH date format), and remove one .br request 
  from inside the table, which is unsupported by FreeBSD 12's mandoc(1) 
  formatter.  FreeBSD Bug#241032, reported by Helge Oldach.
* Further man page fixes and additions by Chris Mayo and Gregor Zattler.
* When evaluating the need for STARTTLS in non-default configurations (SSL 
  certificate validation turned off), fetchmail would only consider --sslproto 
  tls1 as requiring STARTTLS, now all non-empty protocol versions do.
* fetchmailconf now properly writes "no sslcertck" if sslcertck is disabled.
* fetchmailconf now catches and reports OS errors (including DNS errors) when 
  autoprobing.  Reported as Gitlab issue #12 by Sergey Alirzaev.
* fetchmailconf received a host of other bugfixes, see the Git commit log.

## CHANGES:
* Make t.smoke more robust and use temporary directory as FETCHMAILHOME, to make
  sure that the home directory resolves for the user running the test suite
  even if the environment isn't perfect. Reported by Konstantin Belousov,
  analysed by Corey Halpin, FreeBSD Bug#240914.

## UPDATED TRANSLATION - THANKS TO:
* zh_CN: Boyuan Yang [Chinese (simplified)]

--------------------------------------------------------------------------------
fetchmail 6.4.1 (released 2019-09-28, 27473 LoC):

## REGRESSION FIXES:
* The bug fix Debian Bug#941129 was incomplete and caused
  + a regression in the default file locations, so that fetchmail was no longer
    able to find its configuration files in some situations.
    Reported by Cy Schubert, Christian Ebert.
  + a regression under _FORTIFY_SOURCE where PATH_MAX > minimal _POSIX_PATH_MAX.

--------------------------------------------------------------------------------
fetchmail 6.4.0 (released 2019-09-27, 27429 LoC):

# NOTE THAT FETCHMAIL IS NO LONGER PUBLISHED THROUGH IBIBLIO.
* They have stopped accepting submissions and consider themselves an archive.

## SECURITY FIXES THAT AFFECT BEHAVIOUR AND MAY REQUIRE RECONFIGURATION
* Fetchmail no longer supports SSLv2.

* Fetchmail no longer attempts to negotiate SSLv3 by default,
  even with --sslproto ssl23. Fetchmail can now use SSLv3, or TLSv1.1 or a newer
  TLS version, with STLS/STARTTLS (it would previously force TLSv1.0 with
  STARTTLS).  If the OpenSSL version used at build and run-time supports these
  versions, --sslproto ssl3 and --sslproto ssl3+ can be used to re-enable SSLv3.
  Doing so is discouraged because the SSLv3 protocol is broken.

  Along the lines suggested - as patch - by Kurt Roeckx, Debian Bug #768843.

  While this change is supposed to be compatible with common configurations,
  users may have to and are advised to change all explicit --sslproto ssl2
  (change to newer protocols required), --sslproto ssl3, --sslproto tls1 to
  --sslproto auto, so that they can benefit from TLSv1.1 and TLSv1.2 where
  supported by the server.

  The --sslproto option now understands the values auto, ssl3+, tls1+, tls1.1,
  tls1.1+, tls1.2, tls1.2+, tls1.3, tls1.3+ (case insensitively), see CHANGES
  below for details.

* Fetchmail defaults to --sslcertck behaviour. A new option --nosslcertck to
  override this has been added, but may be removed in future fetchmail versions
  in favour of another configuration option that makes the insecurity in using
  this option clearer.

## SECURITY FIXES
* Fetchmail prevents buffer overruns in GSSAPI authentication with user names
  beyond c. 6000 characters in length. Reported by Greg Hudson.

## CHANGED REQUIREMENTS
* fetchmail 6.4.0 is written in C99 and requires a SUSv3 (Single Unix
  Specification v3, a superset of POSIX.1-2001 aka. IEEE Std 1003.1-2001 with
  XSI extension) compliant system. For now, a C89 compiler should also work
  if the system is SUSv3 compliant.

  In particular, older fetchmail versions had workaround for several functions
  standardized in the Single Unix Specification v3, these have been removed.

  The trio/ library has been removed from the distribution.

## CHANGES
* fetchmail 6.3.X is unsupported.
* fetchmail now configures OpenSSL support by default.
* fetchmail now requires OpenSSL v1.0.2 or newer.
* Fetchmail now supports --sslproto auto and --sslproto tls1+ (same as ssl23).
* --sslproto tls1.1+, tls1.2+, and tls1.3+ are now supported for
  auto-negotiation with a minimum specified TLS protocol version, and --sslproto
  tls1.1, --sslproto tls1.2 and --sslproto tls1.3 to force the specified TLS
  protocol version. Note that tls1.3 requires OpenSSL v1.1.1 or newer.
* Fetchmail now detects if the server hangs up prematurely during SSL_connect()
  and reports this condition as such, and not just as SSL connection failure.
  (OpenSSL 1.0.2 reported incompatible with pop3.live.com by Jerry Seibert).
* A foreground fetchmail can now accept a few more options while another copy is
  running in the background.
* fetchmail now handles POP3 --keep UID lists more efficiently, by using Rainer
  Weikusat's P-Tree implementation. This reduces the complexity for handling
  a large UIDL from O(n^2) to O(n log n) and becomes noticably faster with
  thousands of kept messages.
  (IMAP does not currently track UIDs and is unaffected.)
  At the same time, the UIDL emulation code for deficient servers has been
  removed. It never worked really well.  Servers that do not implement the
  optional UIDL command only work with --fetchall option set, which in itself is
  incompatible with the --keep option (it would cause message duplication).
* fetchmail, when setting up TLS connections, now uses SSL_set_tlsext_host_name()
  to set up the SNI (Server Name Indication). Some servers (for instance
  googlemail) require SNI when using newer SSL protocols.
* Fetchmail now sets the expected hostname through OpenSSL 1.0.2's new 
  X509_VERIFY_PARAM_set1_host() function to enable OpenSSL's native certificate
  verification features.
* fetchmail will drop the connection when fetching with IMAP and receiving an
  unexpected untagged "* BYE" response, to work around certain faulty servers.
* The FETCHMAIL_POP3_FORCE_RETR environment variable is now documented,
  it forces fetchmail, when talking POP3, to always use the RETR command,
  even if it would otherwise use the TOP command.
* Fetchmail's configure stage will try to query pkg-config or pkgconf for libssl
  and libcrypto, in case other system use .pc files to document specific library
  dependencies. (contributed by Fabrice Fontaine, GitLab merge request !14.)
* The gethostbyname() API calls and compatibility functions have been removed.
* These translations are shipped but not installed by default because
  they have less than 500 translated messages out of 714: el fi gl pt_BR sk tr
  -> Greek, Finnish, Galician, Brazilian Portuguese, Slovak, Turkish.
* Fetchmail now refuses delivery if the MDA option contains single-quoted
  expansions. Fixes Debian Bug#347909.

## FIXES
* Fix a typo in the FAQ. Submitted by David Lawyer, Debian Bug#706776.
* Do not translate header tags such as "Subject:".  Reported by Gonzalo Pérez de
  Olaguer Córdoba, Debian Bug#744907.
* Convert most links from berlios.de to sourceforge.net.
* Report error to stderr, and exit, if --idle is combined with multiple
  accounts.
* Point to --idle from GENERAL OPERATION to clarify --idle and multiple
  mailboxes do not mix.  In response to Jeremy Chadwick's trouble 2014-11-19,
  fetchmail-users mailing list.
* Fix SSL-enabled build on systems that do not declare SSLv3_client_method(),
  or that #define OPENSSL_NO_SSL3 inside #include <openssl/ssl.h>
  Related to Debian Bug#775255. Fixes Debian Bug #804604.
* Version report lists -SSLv3 on SSL-enabled no-ssl3 builds.
* Fetchmail no longer adds a NUL byte to the username in GSSAPI authentication.
  This was reported to break Kerberos-based authentication with Microsoft
  Exchange 2013 by Greg Hudson.
* Set umask properly before writing the .fetchids file, to avoid failing the
  security check on the next run.  Reported by Fabian Raab,
  Fixes Debian Bug#831611.
* When forwarding by LMTP, also check antispam response code when collecting
  the responses after the CR LF . CR LF sequence at the end of the DATA phase.
  (Contributed by Evil.2000, GitLab merge request !12.)
* fetchmail will not try other protocols after a socket error. This avoids
  mismatches of how different prococols see messages as "seen" and re-fetches
  of known mail.  (Fix contributed by Lauri Nurmi, GitLab Merge Request !10.)
* fetchmail no longer reports "System error during SSL_connect(): Success."
  Fixes Debian Bug#928916, reported by Paul Kimoto.
* fetchmailconf would ignore Edit or Delete actions on the first (topmost)
  item in a list (no matter if server list, user list, ...).
* The mimedecode feature now properly detects multipart/mixed-type matches, so
  that quoted-printable-encoded multipart messages can get decoded.
  (Regression in 5.0.0 on 1999-03-27, as a side effect of a PGP-mimedecode fix
  attributed to Henrik Storner.)
* FETCHMAILHOME can now safely be a relative path, which will be qualified
  through realpath(). Previously, it had to be absolute in daemon mode.
  Reported by Alex Andreotti, Debian Bug#941129.

## UPDATED TRANSLATIONS - THANKS TO:
* CS: Petr Pisar <petr.pisar@atlas.cz> [Czech]
* EO: Felipe Castro <fefcas@gmail.com> [Esperanto]
* FR: Frédéric Marchal <fmarchal@perso.be> [French]
* JP: Takeshi Hamasaki <hmatrjp@users.sourceforge.jp> [Japanese]
* PL: Jakub Bogusz <qboosh@pld-linux.org> [Polish]
* SV: Göran Uddeborg <goeran@uddeborg.se> [Swedish]

--------------------------------------------------------------------------------

fetchmail-6.3.26 (released 2013-04-23, 26180 LoC):

# CRITICAL BUG FIX for setups using "mimedecode":
* The mimedecode feature failed to ship the last line of the body if it was
  encoded as quoted-printable and had a MIME soft line break in the very last
  line.  Reported by Lars Hecking in June 2011.

  Bug introduced on 1998-03-20 when the mimedecode support was added by ESR
  before release 4.4.1 through code contributed by Henrik Storner.
  Workaround for older releases: do not use mimedecode feature.

  Earlier versions of this NEWS file claimed this bug fixed in fetchmail-6.3.23,
  but it was not.

  Fixes Launchpad Bug#1171818.


fetchmail-6.3.25 (released 2013-03-18, 26149 LoC):

# BUG FIXES
* Fix a memory leak in out-of-memory error condition while handling plugins.
  Report and patch by John Beck (found with Parfait static code analyzer).
* Fix a NULL pointer dereference in out-of-memory error condition while handling
  plugins.
  Report and patch by John Beck (found with Parfait static code analyzer).

# CHANGES
* Improved reporting when SSL/TLS X.509 certificate validation has failed,
  working around a not-so-recent swapping of two OpenSSL error codes, and
  a practical impossibility to distinguish broken certification chains from
  missing trust anchors (root certificates).
* OpenSSL decoded errors are now reported through report(), rather than dumped
  to stderr, so that they should show up in logfiles and/or syslog.
* The fetchmail manual page no longer claims that MD5 were the default OpenSSL
  hash format (for use with --sslfingerprint). Reported by Jakob Wilk,
  PARTIAL fix for Debian Bug#700266.
* The fetchmail manual page now refers the user to --softbounce from the
  SMTP/ESMTP ERROR HANDLING section.  Reported by Anton Shterenlikht.

# WORKAROUNDS
* Older systems that provide the older RFC-2553 implementation of getaddrinfo,
  rather than the current RFC-3493, and systems that do not provide this
  getaddrinfo() interface at all and thus use the replacement functions from
  libesmtp/getaddrinfo.?, might return EAI_NODATA when a host is registered in
  DNS as MX or similar, but without A or AAAA records.  Handle this situation
  when checking for multidrop aliases and treat EAI_NODATA the same as
  EAI_NONAME, i. e. name cannot be resolved.

  The proper fix, however, is to upgrade the operating system.

# TRANSLATION UPDATES
[cs] Czech, by Petr Pisar
[da] Danish, by Joe Hansen
[de] German
[eo] Esperanto, by Sian Mountbatten and Felipe Castro
[fr] French, by Frédéric Marchal
[ja] Japanese, by Takeshi Hamasaki
[pl] Polish, by Jakub Bogusz
[sv] Swedish, by Göran Uddeborg
[vi] Vietnamese, by Trần Ngọc Quân


fetchmail-6.3.24 (released 2012-12-23, 26108 LoC):

# CRITICAL AND REGRESSION FIXES
* Plug a memory leak in OpenSSL's certificate verification callback.
  This would affect fetchmail configurations running with SSL in daemon mode
  more than one-shot runs.
  Reported by Erik Thiele, and pinned by Dominik Heeg,
  fixes Debian Bug #688015.
  This bug was introduced into fetchmail 6.3.0 (committed 2005-10-29)
  when support for subjectAltName was added through a patch by Roland
  Stigge, submitted as Debian Bug#201113.

* The --logfile option now works again outside daemon mode, reported by Heinz
  Diehl. The documentation that I had been reading was inconsistent with the
  code, and only parts of the manual page claimed that --logfile was only
  effective in daemon mode.


fetchmail-6.3.23 (released 2012-12-10, 26106 LoC):

# REGRESSION FIXES
* Fix compilation with OpenSSL implementations before 0.9.8m that lack
  SSL_CTX_clear_options. Patch by Earl Chew.
  Note that the use of older OpenSSL versions with fetchmail is unsupported and
  *not* recommended.

# BUG FIXES
* Fix combination of --plugin and -f -. Patch by Alexander Zangerl,
  to fix Debian Bug#671294.
* Clean up logfile vs. syslog handling, and in case logfile overrides
  syslog, send a message to the latter stating where logging goes.

# CHANGES
* The build process can now be made a bit more silent and concise through
  ./configure --enable-silent-rules, or by adding "V=0" to the make command.

# WORKAROUNDS
* Make Maillennium POP3 workarounds less specific, to encompass
  Maillennium POP3/UNIBOX (Maillennium V05.00c++). Reported by Eddie
  via fetchmail-users mailing list, 2012-10-13.

# TRANSLATION UPDATES
[cs] Czech, by Petr Pisar
[da] Danish, by Joe Hansen
[de] German
[fr] French, Frédéric Marchal
[ja] Japanese, Takeshi Hamasaki
[pl] Polish, by Jakub Bogusz
[sv] Swedish, by Göran Uddeborg
[vi] Vietnamese, Trần Ngọc Quân


fetchmail-6.3.22 (released 2012-08-29, 26077 LoC):

# SECURITY FIXES
* for CVE-2012-3482:
  NTLM: fetchmail mistook an error message that the server sent in response to
  an NTLM request for protocol exchange, tried to decode it, and crashed while
  reading from a bad memory location.
  Also, with a carefully crafted NTLM challenge packet sent from the server, it
  would be possible that fetchmail conveyed confidential data not meant for the
  server through the NTLM response packet.
  Fix: Detect base64 decoding errors, validate the NTLM challenge, and abort
  NTLM authentication in case of error.
  See fetchmail-SA-2012-02.txt for further details.
  Reported by J. Porter Clark.

* for CVE-2011-3389:
  SSL/TLS (wrapped and STARTTLS): fetchmail used to disable a countermeasure 
  against a certain kind of attack against cipher block chaining initialization 
  vectors (SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS).
  Whether this creates an exploitable situation, depends on the server and the 
  negotiated ciphers.
  As a precaution, fetchmail 6.3.22 enables the countermeasure, by clearing 
  SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS.

  NOTE that this can cause connections to certain non-conforming servers to 
  fail, in which case you can set the environment variable 
  FETCHMAIL_DISABLE_CBC_IV_COUNTERMEASURE to any non-empty value when starting
  fetchmail to re-instate the compatibility option at the expense of security.

  Reported by Apple Product Security.

  For technical details, refer to <http://www.openssl.org/~bodo/tls-cbc.txt>.
  See fetchmail-SA-2012-01.txt for further details.

# BUG FIX
* The Server certificate: message in verbose mode now appears on stdout like the
  remainder of the output. Reported by Henry Jensen, to fix Debian Bug #639807.

* The GSSAPI-related autoconf code now matches gssapi.c better, and uses
  a different check to look for GSS_C_NT_HOSTBASED_SERVICE.
  This fixes the GSSAPI-enabled build on NetBSD 6 Beta.

# CHANGES
* On systems where SSLv2_client_method isn't defined in OpenSSL (such as
  newer Debian, and Ubuntu starting with 11.10 oneiric ocelot), don't
  reference it (to fix the build) and if configured, print a run-time error 
  that the OS does not support SSLv2. Fixes Debian Bug #622054,
  but note that that bug report has a more thorough patch that does away with
  SSLv2 altogether.

* The security and errata notices fetchmail-{EN,SA}-20??-??.txt are now
  under the more relaxed CC BY-ND 3.0 license (the noncommercial clause
  was dropped). The Creative Commons address was updated.

* The Python-related Makefile.am parts were simplified to avoid an automake
  1.11.X bug around noinst_PYTHON, Automake Bug #10995.

* Configuring fetchmail without SSL now triggers a configure warning,
  and asks the user to consider running configure --with-ssl.

# WORKAROUND
* Some servers, notably Zimbra, return A1234 987 FETCH () in response to
  a header request, in the face of message corruption.  fetchmail now treats
  these as temporary errors. Report and Patch by Mikulas Patocka, Red Hat.

* Some servers, notably Microsoft Exchange, return "A0009 OK FETCH completed."
  without any header in response to a header request for meeting reminder
  messages (with a "meeting.ics" attachment). fetchmail now treats these as
  transient errors.  Report by John Connett, Patch by Sunil Shetye.

# TRANSLATION UPDATES
* [cs]    Czech, by Petr Pisar
* [de]    German
* [fr]    French, by Frédéric Marchal
* [ja]    Japanese, by Takeshi Hamasaki
* [pl]    Polish, by Jakub Bogusz
* [sv]    Swedish, by Göran Uddeborg --- NEW TRANSLATION - Thank you!
* [vi]    Vietnamese, by Trần Ngọc Quân


fetchmail-6.3.21 (released 2011-08-21, 26011 LoC):

# CRITICAL BUG FIX
* The IMAP client no longer inserts NUL bytes into the last line of a message
  when it is not closed with a LF or CRLF sequence. Reported by Antoine Levitt.
  As a side effect of the fix, and in order to avoid a full rewrite, fetchmail
  will now CRLF-terminate the last line fetched through IMAP, even if it is
  originally not terminated by LF or CRLF. This bears no relevance if your
  messages end up in mbox, but adds line termination for storages (like Maildir)
  that do not require that the last line be LF- or CRLF-terminated.

# CONTRIB/ addition
* There is a patch against fetchnews's source, contrib/rawlog.patch, that can
  log (and hexdump non-printing characters) raw socket data to a file. It proved
  useful to debug Antoine's bug described above.


fetchmail-6.3.20 (released 2011-06-06, 26005 LoC):

# SECURITY BUG FIXES
* CVE-2011-1947:
  STARTTLS: Fetchmail runs the IMAP STARTTLS or POP3 STLS negotiation with the
  set timeout (default five minutes) now. This was reported missing, with
  observed fetchmail freezes beyond a week, by Thomas Jarosch.
     SSL-wrapped connections were unaffected by this timeout, so users of older
  versions can force ssl-wrapped connections -- if supported by the server --
  with the --ssl command line or ssl rcfile option.
  See fetchmail-SA-2011-01.txt for further details.

# BUG FIXES
* IMAP: Do not search for UNSEEN messages in ranges. Usually, there are very few
  new messages and most of the range searches result in nothing. Instead, split
  the long response to make the IMAP driver think that there are multiple lines
  of response. (Sunil Shetye)
* Do not print "skipping message" for old messages even in verbose mode. If
  there are too many old messages, the logs just get filled without any real
  activity. (Sunil Shetye) (suggested by Yunfan Jiang)
* Build: fetchmail now always uses its own MD5 implementation rather than trying
  to find a system library with matched header. The library and header variants
  found on systems are too diverse, and the code size saving is not worth any
  more wasted user or programmer time.

# CHANGES
* Call strlen() only once when removing CRLF from a line. (Sunil Shetye)
* fetchmail sets Internet domain sockets to "keepalive" mode now. Note that
  there is no portable way to configure actual timeouts for this mode, and some
  systems only support a system-wide timeout setting. fetchmail does not
  attempt to tune the time spans of keepalive mode.

# TRANSLATION UPDATES
  [cs]    Chech (Petr Pisar)
  [nl]    Dutch (Erwin Poeze)
  [fr]    French (Frédéric Marchal)
  [de]    German (Matthias Andree)
  [ja]    Japanese (Takeshi Hamasaki)
  [pl]    Polish (Jakub Bogusz)
  [sk]    Slovak (Marcel Telka)


fetchmail-6.3.19 (released 2010-12-10, 25945 LoC):

# ERRATUM NOTICE ISSUED
* fetchmail 6.3.18 contains several bug fixes that were considered sufficiently
  grave to warrant the issue of an erratum notice, fetchmail-EN-2010-03.txt.

# BUG FIXES
* When specifying multiple local multidrop lists, do not lose wildcard flag.
  (Affects "user foo is bar baz * is joe here")
* In multidrop configurations, an asterisk can now appear anywhere in the list
  of local users, not just at the end.
* In multidrop mode, header parsing is now more verbose in -vv mode, so that it
  becomes possible to see which header is used.
* Make --antispam work from command line (these used to work in rcfiles).
  Reported by Kees Bakker, BerliOS Bug #17599. (Sunil Shetye)
* Smoke test XHTML 1.1 validation, and if it fails, skip validating HTML
  documents.  Skip validating Mailbox-Names-UTF7.html. Several systems have
  broken XHTML 1.1 DTD installations that jeopardize the build.
  Reported by Mihail Nechkin against FreeBSD port.
  Workaround for 6.3.18: build in a separate directory, i. e:
  mkdir build && cd build && ../configure --options-go-here
* Send a NOOP only after a failed STARTTLS in IMAP. (Sunil Shetye)
* Demote GSSAPI verbose/debug syslog to INFO severity. Requested by Carlos E. R.
  and Derek Simkowiak via the fetchmail-users@ mailing list.
* Do STARTTLS/STLS negotiation in IMAP/POP3 if it is mandatory even if the
  server capabilities do not show support for upgradation to TLS.
  To use this, configure --sslproto tls1. (Sunil Shetye)
* IMAP: Understand empty strings as FETCH response, seen on Yahoo. Reported by
  Yasin Malli to fetchmail-users@ 2010-12-10.
  Note that fetchmail continues to expect literals as FETCH response for now.

# DOCUMENTATION
* The manual page now links to IANA for GSSAPI service names.

# TRANSLATION UPDATES
  [cs]    Czech (Petr Pisar)
  [fr]    French (Frédéric Marchal)
  [de]    German
  [it]    Italian (Vincenzo Campanella)
  [pl]    Polish (Jakub Bogusz)


fetchmail-6.3.18 (released 2010-10-09, 25936 LoC):

# SECURITY IMPROVEMENTS TO DEFANG X.509 CERTIFICATE ABUSE
* Fetchmail now only accepts wildcard certificate common names and subject
  alternative names if they start with "*.". Previous versions would accept
  wildcards even if no period followed immediately.
* Fetchmail now disallows wildcards in certificates to match domain literals
  (such as 10.9.8.7), or wildcards in domain literals ("*.168.23.23").
  The test is overly picky and triggers if the pattern (after skipping the
  initial wildcard "*") or domain consists solely of digits and dots, and thus
  matches more than needed.
* Fetchmail now disallows wildcarding top-level domains.

# CRITICAL BUG FIXES AND REGRESSION FIXES
* Fetchmail 6.3.15, 6.3.16, and 6.3.17 would pick up libmd5 to obtain MD5*
  functions, as an effect of an undocumented Solaris MD5 fix.
  This caused all MD5-related functions to malfunction if, for instance,
  libmd5.so was installed on other operating systems as part of libwww on
  machines where long isn't 32-bits, i. e. usually on 64-bit computers.
  Fixes Gentoo Bug #319283, reported, including libwww hint, by Karl Hakimian.
  Side effect: fetchmail will now use -lmd on Solaris rather than -lmd5.
* Fetchmail 6.3.17 warned about insecure SSL/TLS connections even if a matching
  --sslfingerprint was specified. This is an omission from an SSL usability
  change made in 6.3.17.
  Fixes Debian Bug#580796 reported by Roland Stigge.
* Fetchmail will now apply timeouts to the authentication stage.
  This stage encompasses STARTTLS/STLS negotiation in IMAP/POP3.
  Reported missing by Thomas Jarosch.
* Fetchmail now cancels GSSAPI authentication properly when encountering GSS
  errors, such as no or unsuitable credentials.
  It now sends an asterisk on a line by its own, as required in SASL.
    This fixes protocol synchronization issues that cause Authentication
  failures, often observed with kerberized MS Exchange servers.
  Fixes Debian Bug #568455 reported by Patrick Rynhart, and Alan Murrell, to the
  fetchmail-users list. Fix verified by Thomas Voigtmann and Patrick Rynhart.

# BUG FIXES
* Fetchmail will no longer print connection attempts and errors for one host
  in "silent" and "normal" logging modes, unless all connections fail. This
  should reduce irritation around refused-connection logging if services are
  only on an IPv4 socket if the host also supports IPv6. Often observed as
  connections refused to ::1/25 when the subsequent connection to 127.0.0.1/25
  then - silently - succeeds.  Fetchmail, unless in verbose mode, will collect
  all connect errors and only report them if all of them fail.
* Fetchmail will not try GSSAPI authentication automatically, unless it has GSS
  credentials. However, if GSSAPI authentication is requested explicitly,
  fetchmail will always try it.
* Fetchmail now parses response to "FETCH n:m RFC822.SIZE" and "FETCH n
  RFC822.HEADER" in a more flexible manner. (Sunil Shetye)
* The manual page clearly states that --principal is for Kerberos 4 only, not
  for Kerberos 5 or GSSAPI. Found by Thomas Voigtmann.

# CHANGES
* When encountering incorrect headers, fetchmail will refer to the bad-header
  option in the manpage.
  Fixes BerliOS Bug #17272, change suggested by Björn Voigt.
* Fetchmail now decodes and reports GSSAPI status codes upon errors.
* Fetchmail now autoprobes NTLM also for POP3.
* The Fetchmail FAQ has a new item #R15 on authentication failures.

# INTERNAL CHANGES
* The common NTLM authentication code was factored out from pop3.c and imap.c.

# TRANSLATION UPDATES
  [zh_CN] Chinese/simplified (Ji Zheng-Yu)
  [cs]    Czech (Petr Pisar)
  [nl]    Dutch (Erwin Poeze)
  [fr]    French (Frédéric Marchal)
  [de]    German
  [it]    Italian (Vincenzo Campanella)
  [ja]    Japanese (Takeshi Hamasaki)
  [pl]    Polish (Jakub Bogusz)
  [sk]    Slovak (Marcel Telka)


fetchmail-6.3.17 (released 2010-05-06, 25767 LoC):

# SECURITY FIX
* CVE-2010-1167: Fetchmail before release 6.3.17 did not properly sanitize
  external input (mail headers and UID). When a multi-character locale (such as
  UTF-8) was in use, this could cause memory exhaustion and thus a denial of
  service, because fetchmail's report.c functions assumed that non-success of
  [v]snprintf was due to insufficient buffer size allocation. It would then
  repeatedly reallocate a larger buffer and fail formatting again.
  See fetchmail-SA-2010-02.txt.

# FEATURES
* Fetchmail now supports a --sslcertfile <file> option to specify a "CA bundle"
  file (a file that contains trusted CA certificates). Since these bundled CA
  files do not require c_rehash to be run, they are easier to use and immune to
  OpenSSL library updates that affect the hash function.
* Fetchmail now supports a FETCHMAIL_INCLUDE_DEFAULT_X509_CA_CERTS
  environment variable to force loading the default SSL CA certificate
  locations even if --sslcertfile or --sslcertpath is used.
  If neither option is in effect, fetchmail loads the default locations.

# REGRESSION FIX
* Fix string handling in rcfile scanner, which caused fetchmail to misparse a
  run control file in certain circumstances.  Fixes BerliOS bug #14257.
  Patch by Michael Banack.  This fixes a regression introduced before 6.3.0.

# BUG FIXES
* Plug memory leak when using a "defaults" entry in the run control file.
* Do not print SSL certificate mismatches unless verbose or --sslcertck is
  enabled.
* Do not lose "set invisible" in fetchmailconf. (Michael Barnack)

# CHANGES
* Usability: SSL certificate chains are fully printed in -v -v mode, and there
  are now helpful pointers to --sslcertpath and c_rehash for "unable to get
  local issuer certificate" and self-signed certificates -- these usually hint
  to missing root signing CAs in the certs directory.
* Several fixes for compiler (GCC, Intel C++, CLang) and autotools warnings
* Memory allocation failures will now cause abnormal program abort (SIGABRT),
  no longer an exit with unspecified code.
* Print a warning if certificate verification failed and the user did not
  specify --sslcertck.

# DOCUMENTATION
* Fix table of global option to read "set softbounce" where there used to be a
  2nd copy of "set spambounce".  Patch by Michael Banack, BerliOS Bug #17067.
* In the --sslcertpath description, mention that OpenSSL upgrade (and a 0.9.X
  to 1.0.0 upgrade in particular) may require running c_rehash.

# TRANSLATION UPDATES
  [zh_CN] Chinese/simplified (Ji Zheng-Yu)
  [cs]    Czech (Petr Pisar)
  [nl]    Dutch (Erwin Poeze)
  [fr]    French (Frédéric Marchal)
  [de]    German
  [id]    Indonesian (Andhika Padmawan)
  [it]    Italian (Vincenzo Campanella)
  [ja]    Japanese (Takeshi Hamasaki)
  [pl]    Polish (Jakub Bogusz)
  [sk]    Slovak (Marcel Telka)
  [vi]    Vietnamese (Clytie Siddall)


fetchmail-6.3.16 (released 2010-04-06, 25574 LoC):

# BUG FIX
* Fix --interface option, broken in 6.3.15. Reported by Vladmimir Stavrinov.
  Fixes Debian Bug #576717.

# CHANGE
* Call OpenSSL_add_all_algorithms(). This is needed to support non-mandatory
  and non-standard algorithms in certificates.
  Sjoerd Simons, to fix Debian Bug #576430.
  OpenSSL 0.9.8* does not load - for instance - the SHA256 digest by default.
  Reported as OpenSSL RT#2224.


fetchmail-6.3.15 (released 2010-03-28, 25572 LoC):

# FEATURE
* Fetchmail now supports a bad-header command line or rcfile option that takes
  exactly one argument, accept or reject (default).  This specifies how messages
  with bad headers retrieved from the current server are to be treated.

# BUG FIXES
* In the rcfile, recognize "local" as abbreviation for "localdomains", as
  documented. The short form has not ever worked since this feature was added in
  January 1997. Reported by Frédéric Marchal.
* Do not close stdout when using mda and "bsmtp -" at the same time.
* Log operating system errors when BSMTP writes fail.
* Fix verbose mode progress formatting regression from 6.3.10; SMTP trace lines
  were no longer on a line of their own. Reported by Melchior Franz.
* Check seteuid() return value and abort running MDA if switch fails.
* Set global flags in a consistent manner. Make --nosoftbounce and
  --nobounce work from command line (these used to work in rcfiles).
  Reported and fix confirmed working by N.J. Mann. (Sunil Shetye)
* Properly import h_errno declarations, even on systems where h_errno isn't a
  macro. (Adds ./configure check, fixes Cygwin dllimport warnings.)

# CHANGES
* The repository has been converted and moved from the Subversion (SVN) format
  kindly hosted by Graham Wilson over the past years to Git format hosted on
  Gitorious.org.  My deepest thanks to Graham Wilson for this service that
  kept us going when BerliOS's Subversion service was faulty in its early days.
* This opportunity was used to convert BRANCH_6-2 and BRANCH_1-9-9 to
  GnuPG-signed tags, as a sign that these are now closed.
* The outdated SVN trunk is now called "oldtrunk" in Git just to save the work
  for future reference. All development in the past few years was on BRANCH_6-3.
* master was branched from BRANCH_6-3.  BRANCH_6-3 is now obsolete (and in fact
  was also converted to a tag to record where the conversion from SVN to Git
  took place).
* "make check" now skips HTML validation if xmllint or XHTML DTD are missing.

# DOCUMENTATION
* Web site and documentation were adjusted to reflect the SVN->Git move.
* The fetchmail manual page is now much clearer on the user id switching
  (seteuid) when using --mda while running as the super user.

# TRANSLATION UPDATES, by language name
* [zh_CN] Chinese (Simplified), by Ji Zheng-Yu
* [cs]    Czech, by Petr Pisar
* [nl]    Dutch, by Erwin Poeze
* [fr]    French, by Frédéric Marchal
* [de]    German
* [id]    Indonesian, by Andhika Padmawan
* [it]    Italian, by Vincenzo Campanella
* [ja]    Japanese, by Takeshi Hamasaki
* [pl]    Polish, by Jakub Bogusz
* [vi]    Vietnamese, by Clytie Siddall


fetchmail 6.3.14 (released 2010-02-05, 25487 LoC):

# SECURITY FIXES
* CVE-2010-0562: SSL/TLS certificate information is now also reported properly
  on computers that consider the "char" type signed. Fixes malloc() buffer
  overrun.  Workaround for older versions: do not use verbose mode.
  See fetchmail-SA-2010-01.txt for details, including a minimal patch.

# BUG FIXES
* The IMAP client no longer skips messages from several IMAP servers including
  Dovecot if fetchmail's "idle" is in use.  Causes were that fetchmail (a)
  ignored some untagged responses when it should not (b) relied on EXISTS
  messages in response to EXPUNGE, which aren't mandated by RFC-3501 (the IMAP
  standard) and aren't sent by Dovecot either.
    Fix by Sunil Shetye (the fix also consolidates IMAP response handling,
  improving overall robustness of the IMAP client), bug report and testing by
  Matt Doran, with further hints from Timo Sirainen.
* The SMTP client now recovers from errors (such as servers dropping the
  connection after errors) when sending an RSET command.
    Fix by Sunil Shetye. Report by James Moe.
* The IMAP client now uses "SEARCH UNSEEN" rather than "SEARCH UNSEEN NOT
  DELETED" again on IMAP2, to fix a regression in fetchmail 6.2.5 reported by
  Will Stringer in June 2004. (Sunil Shetye)
* The IMAP client now uses "SEARCH UNSEEN UNDELETED" on IMAP4 and IMAP4r1
  servers (Sunil Shetye).
* Workaround: The IMAP client now falls back to "FETCH n:m FLAGS" if the server
  does not support "SEARCH". (Sunil Shetye)
* The IMAP client now requests message numbers in batches of 1,000 to avoid
  problems if there are more than 1860 unseen messages. (Sunil Shetye)
    Note that this wasn't security relevant because fetchmail would only read up
  to the maximum buffer size and leave the remainder of the string unread, going
  out of synch afterwards.
* Stricter validation of IMAP responses containing byte or message counts.

# CHANGES
* Only include gssapi.h if we're not including gssapi/gssapi.h, to fix a FreeBSD
  compiler warning about gssapi.h being obsolete.

# DOCUMENTATION
* The README.SSL document was revised for grammar, spelling, and clarity.
  Courtesy of Robert Mullin.

# TRANSLATION UPDATES
* [it]    Italian, by Vincenzo Campanella



fetchmail 6.3.13 (released 2009-10-30, 25333 LoC):

# REGRESSION FIXES
* The multiline SMTP error fix in release 6.3.12 caused fetchmail to lose
  message codes 400..599 and treat all of these as temporary error. This would
  cause messages to be left on the server even if softbounce was turned off.
  Reported by Thomas Jarosch.

# TRANSLATION UPDATES
* [cs]    Czech, by Petr Pisar
* [zh_CN] Chinese (simplified), by Ji ZhengYu
* [nl]    Dutch, by Erwin Poeze
* [id]    Indonesian, by Andhika Padmawan
* [ja]    Japanese, by Takeshi Hamasaki
* [pl]    Polish, by Jakub Bogusz
* [es]    Spanish (Castilian), by Franciso Molinero
* [vi]    Vietnamese, by Clytie Siddall


fetchmail 6.3.12 (released 2009-10-05):

# REGRESSION FIXES
* The CVE-2009-2666 fix in fetchmail release 6.3.11 caused a free() of
  unallocated memory on SSL connections, which caused crashes or program aborts
  on some systems (depending on how initialization and free() of unallocated
  memory is handled in compiler and libc).
  Workaround for older versions: run in verbose mode.
  Patch courtesy of Thomas Heinz, fixes Gentoo Bug #280760.
  This regression affected only the 6.3.11 release, but not the patch that was
  part of the security announcement fetchmail-SA-2009-01.

# BUG FIXES
* Fix error reporting for GSSAPI on Heimdal (h5l) Kerberos.
* Look for MD5_Init in libcrypto rather than libssl, fixes Gentoo Kerberos
  builds; fixes upstream parts of Gentoo Bugs #231400 and #185652, and fixes
  BerliOS Bug #16134.
* Report multiline SMTP errors properly, reported by Earl Chew; fixes Debian Bug
  #529899, reported by Akihiro Terasaki.
  Note: This fix introduced a regression, fixed in 6.3.13.
* Replace control characters in SMTP replies by '?'.
* Fetchmailconf: Fix descriptions for smtpaddress and smtpname options;
  smtpaddress is for RCPT TO, not MAIL FROM. Found by Gerard Seibert.

# TRANSLATION UPDATES AND ADDITIONS (ordered by language name):
* [ca]    Catalan (Ernest Adrogué Calveras)
* [zh_CN] Chinese/Simplified (Ji ZhengYu)
* [cs]    Czech (Petr Pisar)
* [ja]    Japanese (Takeshi Hamasaki)
* [pl]    Polish (Jakub Bogusz)
* [es]    Spanish/Castilian (Francisco Molinero)
* [vi]    Vietnamese (Clytie Siddall)


fetchmail 6.3.11 (released 2009-08-06):

# SECURITY BUGFIXES
* CVE-2009-2666: SSL NUL prefix impersonation attack through NULs in a
  part of a X.509 certificate's CommonName and subjectAltName fields. These
  fields use opaque strings with a separate length field, so that the NUL
  character isn't a special character inside the certificate. Fetchmail, being
  written in the C language, used to treat these strings as C strings
  nonetheless, so that the domain comparison would end at the first embedded NUL
  character, rather than at the real end of the string.
    Fetchmail will now abort certificate verification as failed if NULs are
  encountered inside either of these fields regardless of their position, and
  drop the connection even if --sslcertck is not used, because NUL is not a
  valid character in legitimate DNS names.
  See fetchmail-SA-2009-01.txt for details, including a minimal patch.

# BUGFIXES
* Remove the spurious message "message delimiter found while scanning headers".
  RFC-5322 syntax states that the delimiter is part of the body, and the body is
  optional.
* Convert all non-printable characters in certificate Subject/Issuer
  Common Name or Subject Alternative Name fields to ANSI-C hex escapes (\xnn,
  where nn are hex digits).
  Note that this change introduces a regression, fixed in 6.3.12.
  See the 6.3.12 documentation above for details and a workaround.

# TRANSLATION UPDATES AND ADDITIONS (ordered by language name):
* [zh_CN] Chinese/Simplified (Ji ZhengYu)
* [es]    Spanish/Castilian (Francisco Molinero)


fetchmail 6.3.10 (released 2009-07-02):

# INCOMPATIBLE BUGFIXES AND CHANGES
* Fetchmail no longer drops permanently undelivered messages by default, to
  match historic documentation.  It does this by adding a new "softbounce"
  option, see below.
  Fixes Debian Bug#471283, demotes Debian Bug#494418 to wishlist.
* There is a new "softbounce" global option that prevents the deletion of
  messages that have not been forwarded. It defaults to "true" for fetchmail
  6.3.X in order to match historic documentation. This may change its default
  in the next major release.

# BUGFIXES
* Fix misuse of canonical autoconf target as _TARGET when it should have been
  _HOST. Report and patch courtesy of Diego E. "Flameeyes" Pettenò.
  Details: http://blog.flameeyes.eu/2009/01/01/the-canonical-target
* Do not lose PS_MAXFETCH (13) exit status when hitting maxpoll. Reported by
  Michelle Konzack, Debian Bug#508667.
* Do not overlap source and destination fields in snprintf() in interface.c.
  Courtesy of Nico Golde, Debian.
* When a pre- or post-connect command fails, now report the exit status or
  termination signal properly through sys/wait.h macros.
* When acquiring a body, understand NIL ("no such data item"), as returned by
  some MS Exchange versions. Fixes BerliOS Bug #11980 by KB Sriram.
* Make progress tickers (-v/--showdots) consistent, and update documentation 
  accordingly ("." for each 1024 octets read, "#" for a header written, and "*" 
  for each body line written.)
  The conditions under which these had been printed were inconsistent,
  illogical, and documentation hadn't matched real behaviour for long.
* For NTLM authentication, use dynamically allocated buffers.
  Fixes Debian Bug#449179, reported by Stepan Golosunov.
* Non-delivery notice ("bounce mail") now mentions the original reason again,
  before the address list. This fixes a regression introduced in 6.3.0.
* Several compiler warnings were fixed.
* The minimum recommended SMTP (RFC-5321) timeouts are enforced to leave
  sufficient time for the listener to respond. Some synchronous listeners,
  particularly when used with spam filtering and other policy enforcement
  services, take extended amounts of time to process messages after the sender,
  recipient, or data block and EOM line. This can cause fetchmail to not wait
  long enough for the "250 Ok" and make fetchmail believe the message wasn't
  properly delivered when in fact it was; fetchmail would then retry the
  download next time and never make progress.
  Fixes Berlios Bug #10972, reported by Viktor Binzberger.
* The ESMTP/LMTP client will now apply an application-specific timeout while
  waiting for the EHLO/LHLO response, rather than wait for the server or TCP
  connection timeout.
* Treat 530 errors as temporary, so as not to delete messages on configuration
  errors. Partially taken from Petr Cerny's patch in Novell Bugzilla #246829.
  The 501 part of said patch was not added, as the maintainer is not convinced
  501 is a temporary condition, and softbounce takes care of this anyways.

# CHANGES
* Make the comparison of the SSL fingerprints case insensitive, to
  ease its use. Suggested by Daniel Richard G.
* Proper precedence ordering for the syslog and logfile options. If the logfile
  option is effective (i. e. we're in daemon mode and nodetach isn't used),
  reset the syslog option. If logfile is ineffective (we're not in daemon mode,
  or nodetach is set), syslog takes precedence.
* The sleeping at/awakened at messages appear in logfiles and syslog only if
  verbose mode is enabled.  On the console, they will still appear without
  verbose mode.  Fixes Debian Bug#282259.
* fetchmail only requests IPv6 addresses via name service if at least one is
  configured on the local host, likewise for IPv4.  (AI_ADDRCONFIG flag to
  getaddrinfo()) Extended version of Redhat's patch.
* If the server name contains "yahoo.com", offers the "ID" capability, and we're
  polling via IMAP, send an ID ("guid" "1") transaction first, ignoring its
  result. This appears needed to be able to log into Yahoo's Zimbra servers, but
  there are open issues (such as being only able to download one message and
  server certificate mismatches).

# CHANGES TO CONTRIB
* Fix bashism in contrib/fetchsetup. Fixes Debian Bug#530081.

# DOCUMENTATION
* Some parts of the the manual page were revised for clarity, accuracy, and
  updated recommendations (particularly SSL/TLS) and formatting conventions from
  man-pages(7).
* The README and README.SSL documents were updated.
* A document, README.SSL-SERVER, was added to describe server-side requirements
  for proper SSL and/or TLS service offerings. These are not specific to
  fetchmail.
* Documentation on how to make "NOMAIL" (exit code 1) not treated an error has
  been added to the EXIT CODES section of the manpage and to the FAQ as item C8.
  The suggested solution uses a tiny POSIX shell script fragment.
  Fixes Debian Bug #530749, filed by Reuben Thomas.

# TRANSLATION UPDATES AND ADDITIONS (ordered by language name):
* [cs]    Czech (Petr Pisar)
* [en_GB] English/British
* [de]    German
* [id]    Indonesian (Andhika Padmawan)
* [it]    Italian (Vincenzo Campanella)
* [ja]    Japanese (Takeshi Hamasaki)
* [pl]    Polish (Jakub Bogusz)
* [ru]    Russian (Pavel Maryanov), fixing Debian Bug #531925
* [es]    Spanish/Castilian (Francisco Molinero)
* [zh_CN] Chinese/Simplified (Ji ZhengYu)


fetchmail 6.3.9 (released 2008-11-16):

# SECURITY AND CRITICAL BUG FIXES:
* CVE-2007-4565: Denial of service: When fetchmail tries to inject a warning
  message it created itself, and the message is refused by the SMTP listener,
  fetchmail dereferences a NULL pointer and crashes. Report & fix by Earl Chew.
  Note while this is theoretically a remote denial of service attack vector,
  fetchmail by default talks SMTP to the localhost, so the overall risk is
  rather low.
  This bug was apparently introduced on 1998-11-27 when the bouncemail facility
  was modularized. The bug then made its appearance in fetchmail release 4.6.8.
  See also fetchmail-SA-2007-02.txt.
* CVE-2008-2711: Denial of service: When fetchmail logs data blobs
  (for instance, a To: header in -v -v verbose mode) in excess of 2048
  bytes, it will crash, because it hands an uninitialized argument
  pointer (not the format string though) to vsnprintf and reads a
  random memory location (it calls va_arg() too often without
  resetting it with va_start()). Based on a patch (BerliOS patch #2492)
  by Petr Uzel, fixes Novell Bug #354291.
  Note 6.3.9-rc1 did not completely fix this issue, so it was redrawn a few 
  hours after its release.
  See also fetchmail-SA-2008-01.txt.
* When expunging, mark the right messages as seen to avoid message loss in "keep
  flush" configurations.  Workaround for previous versions: "expunge 0".
  Report and patch by Alexander Cherepanov - thanks a lot, Berlios Bug #11797,
  "imap_mark_seen doesn't consider expunged messages".
* SSL fix: close memory leak when SSL connection fails; fetchmail used to forget
  calling SSL_free() on the SSL context, leaking in excess of 500 kB RAM on a
  x86_64 system per failed SSL connection attempt.
  Bug reported and patch provided by Seiichi Ikarashi, Fujitsu.

# BUG FIXES:
* The configure script will additionally check for 'dn_skipname', to fix build
  failures with µClibc. The new check still recognizes the resolver libraries on
  Ubuntu 7.04, openSUSE 10.2, Solaris 8, NetBSD 4.0_BETA2 and FreeBSD 6.2.
  Fixes Gentoo bug #134187.
  NOTE: this is a bit of a hack, since we twist the HAVE_RES_SEARCH result, but
  res_search() and dn_skipname() are only used together and scheduled for
  removal in future versions, so this is probably fine.
* No longer complain about invalid sslproto "" when POP3 CAPA probe fails.
  Fixes Debian Bug#421446 (Holger Leskien), Novell Bug #247233 (Jon Nelson),
  Red Hat Bug#503881.
  Thanks to Matthias Strauß for a configuration to reproduce the issue.
* Allow .fetchmailrc and .fetchids to be symlinks, as the manpage does not
  document they aren't allowed - fixes Debian Bug #452907 (Roger Leigh).
  TOCTOU race persists.
* fetchmailconf quotes mailbox (folder) names when writing the configuration.
  Fixes BerliOS Bug #13207 (reported + fix suggested by Terry Brown).
* Only print "Deleting fetchids file" if there actually is one.
  Fixes Debian Bug#374514, reported by Dan Jacobson.
* SSL fix: check and report if SSL_set_fd fails.

# CHANGES:
* autoconf 2.60 is now required to build fetchmail; it uses
  AC_USE_SYSTEM_EXTENSIONS to replace AC_AIX, AC_MINIX, and the like.
* Removed dead FETCHMAIL_DEBUG code from fetchmail.h that was disabled by 
  default with no switches in configure to enable it. However, the macro would 
  have been prone to a symlink attack. Found by Nico Golde.
* Removed dead FORCE_STUFFING code from socket.c that was disabled by default
  with no switches in configure to enable it.
* Include the typedef for int16 in the #ifndef _AIX in smbencrypt.c (Peter
  O'Gorman)
* Correct check for u_int32_t in configure.ac (seems to be typedef'ed in
  namser.h on some platforms.) (Peter O'Gorman)
* In configure.ac change all CPFLAGS to CPPFLAGS, CEFLAGS to CFLAGS and LDEFLAGS
  to LDFLAGS otherwise the results of some tests (additional -L and -I flags) do
  not get used for later tests causing incorrect configure results. Makefile.am
  was also changed to reflect this. (Peter O'Gorman)
* m4/gethostbyname_r.m4 does AC_TRY_COMPILE, which unfortunately can pass even
  if there is no gethostbyname_r. Changed to AC_TRY_LINK. (Peter O'Gorman)
* Revise getnameinfo check to ensure NULL is defined and the result is properly
  evaluated, to avoid bogus results on for instance FreeBSD and redefinitions of
  NI_* at compile time. (Matthias Andree).
* __attribute__ ((unused)) is a gccism, removed from libesmtp/gethostbyname.c.
  (Peter O'Gorman)
* In KAME/getnameinfo.c it's best to use the correct argument to inet_ntoa.
  (Peter O'Gorman)
* In verbose mode, log if --check mode is enabled.
* Add sslcommonname option (rcfile and commandline) as a way to work around
  misconfigured upstream SSL servers that use the wrong certificate name. It
  specifies which CommonName fetchmail expects and logs. (Daniel Richard G.)
* Changed CRLF to LF line endings in contrib/delete-later (reporter: Petr Uzel)
* SSL change: enable all workarounds with SSL_CTX_set_options(ctx,SSL_OP_ALL)
* All translations have been re-enabled, in an attempt to rekindle translator or
  user interest.

# DOCUMENTATION:
* Add fetchmail-SA-2007-02.txt and fetchmail-SA-2008-01.txt.
* Re-add two lines to the manual page that had accidentally become comments 
  to nroff. One was part of the --sslproto documentation, and one in the 
  "Awakening the background daemon" section.
* The manual page no longer asserts that .fetchids were for exclusive POP3 use, 
  since it is planned to use the file with IMAP4 later.
* Add grammar fixes from Dan Jacobson to fetchmail.man. Debian Bug #461642.
* The manual page now mentions that user descriptions need to come before user
  options. Reported by Francensco Pontortì, to fix Debian Bug #467010.
* The manual page no longer hints that multi-user declarations per server were
  only useful in daemon mode running as root, to avoid hinting people to doing
  that.
* Several manual page rcfile examples now include "ssl".
* The manual page hints that option arguments beginning with numbers can be
  enclosed in quotes.
* The manual page now mentions that the --logfile must already exist before
  fetchmail is run.
* The FAQ now recommends (#I9) not to use Google Mail for their disregard to the
  protocols they claim to support.
* Documentation and program output now /consistently/ claim that the rcfile must
  not have more than 0700 (u=rwx,g=,o=) permissions, but fetchmail will still
  silently accept additional g=x permissions for compatibility with previous
  6.2.X and 6.3.X versions.
  Inconsistency (program 0710, manpage 0600) reported by Petr Uzel.
* The --logfile documentation is now clearer about requiring detached daemon 
  mode.

# TRANSLATION UPDATES AND ADDITIONS (ordered by language name):
* [sq]    Albanian (Besnik Bleta)
* [zh_CN] Chinese, simplified (Ji Zheng-Yu)
* [cs]    Czech (Petr Pisar)
* [da]    Danish (Byrial Ole Jensen) - outdated, but newer than in 6.3.8
* [nl]    Dutch (Tony Vroon, Benno Schulenberg)
* [en_GB] English, British
* [fi]    Finnish (Lauri Nurmi)
* [de]    German
* [id]    Indonesian (Andhika Padmawan)
* [ja]    Japanese (Takeshi Hamasaki)
* [pl]    Polish (Jakub Bogusz)
* [ru]    Russian (Pavel Maryanov)
* [es]    Spanish (Javier Fernández-Sanguino Peña, Matthias Andree)
* [tr]    Turkish (Engin Gündüz) - outdated, but newer than in 6.3.8
* [vi]    Vietnamese (Clytie Siddall)



fetchmail 6.3.8 (released 2007-04-06):

# SECURITY STRENGTHENING:
* Make the APOP challenge parser more distrustful and have it reject challenges
  that do not conform to RFC-822 msg-id format, in the hope to make mounting
  man-in-the-middle attacks (MITM) against APOP a bit more difficult.
  (CVE-2007-1558, reported by Gaëtan Leurent, published 2007-04-02 on Bugtraq)

  APOP is claimed insecure by Gaëtan Leurent for MITM scenarios for typical
  setups: based on MD5 collisions, it is purportedly possible to recover the
  first three characters of the shared secret (password), which would then make
  recovery of the shared secret a matter of hours or minutes; this would then
  enable the attacker to impersonate the client vis-à-vis the server.

  For further details, check
  * Gaëtan Leurent, "Message Freedom in MD4 and MD5 Collisions: Application
  to APOP", Fast Software Encryption 2007, Luxembourg. (Proceedings to appear in
  Springer's Lecture Notes on Computer Science.)
  * The mailing list discussion thread at
  <http://lists.berlios.de/pipermail/fetchmail-devel/2007-March/000887.html>

# BUG FIXES:
* Fix pluralization of oversized-message warning mails.
* Fix manual page: --sslcheck -> --sslcertck, and do not set trailing 
  "recommended:" in bold. Fixes Debian Bug #413059, reported by Rafal Czlonka.
* Repoll immediately if a protocol error happens during the authentication 
  attempt after a failed opportunistic TLS upgrade.
  Fixes comment #9 in Gentoo Bug #163782, reported by Takuto Matsuu.
* Fix rendering of the "24 - 26, 28, 29" paragraph in the exit codes section. 
  Reported by Nico Golde.
* If SOCKS support was compiled in, add 'socks' to the feature_options Python
  list emitted in --configdump. Reported by Rob MacGregor.
* Do not crash with a null pointer dereference when opening the BSMTP file 
  fails. Improve error checking and reporting. Reported by Reto Schüttel,
  Debian Bug#416625. Fix based on a patch by Nico Golde.
* Make BSMTP output actually work, it would persistently fail with SOCKET error
  after writing the first header. Bug independently found and reported in
  excellent detail by Reto Schüttel, Debian Bug#416812.

# DOCUMENTATION:
* Add fetchmail-SA-2007-01.txt
* Extend --mda documentation, discourage use of qmail-inject.
  Based on a patch by Rob MacGregor.
* Document SOCKS configuration facility (SOCKS_CONF environment variable).
  Thanks to Jochen Hayek, Michael Shuldman and Rob MacGregor.
* Use envelope option in multidrop example. Patch by Rob MacGregor.
* Document expected Received: line format when parsing for envelope addressees.
* Stripped option documentation from sample.rcfile, since this is bound to go
  out of synch with the manual page, which is the only reference on options.
* Mention that --limit default is 0 bytes, which is special for "no limit".
* Corrected Robert M. Funk's name that I misspelled. My sincere apologies
  -- Matthias Andree.

# CONTRIB:
* Add delete-later and delete-later.README, a script and documentation for
  a MySQL/Tcl-based client-side "delete-after" feature.
  Kindly donated by Yoo GmbH, Großvoigtsberg, Germany (Carsten Ralle).


fetchmail 6.3.7 (released 2007-02-18):

# FIXES FOR REGRESSIONS IN 6.3.6
* Fix KPOP. Patch by Miloslav Trmac.
* Fix repoll when server disconnects after opportunistic TLS failed for POP3.
  Berlios Bug #10133 = Gentoo Bug #163782 reported by Andrej Kacian.

# TRANSLATION UPDATES
* Japanese (Takeshi Hamasaki), Polish (Jakub Bogusz)

# CHANGES
* Consider getaddrinfo() on Darwin 9 (Mac OS X 10.5 "Leopard") thread-safe.
  Reported by Uli Zappe.


fetchmail 6.3.6 (released 2007-01-04):

# SECURITY FIXES:
* CVE-2006-5867, fetchmail-SA-2006-02.txt:
  Password disclosure vulnerability fixed. This has several aspects:

  - Fetchmail now implies sslproto 'tls1' if the sslfingerprint or sslcertck
    options are used and the ssl option is not used, in order to be sure that
    fetchmail gets a certificate from the mail server.

  - Fetchmail breaks the connection if the TLS negotiation (or verification, if
    requested) fails with sslproto 'tls1', sslfingerprint or sslcheck enabled.

  - POP3 connections now use STLS reliably. They used to ignore STLS altogether
    for serveral values of the "auth" option, when fetchmail forget to probe
    server capabilities - see fetchmail-SA-2006-02.txt for details.

  - POP3 connections will no longer fall back USER/PASS authentication if
    strong challenge-response authenticators such as CRAM-MD5 are configured
    but the server does not advertise these in its CAPA response.

  - POP2 is obsolete and does not support STLS or anything beyond password-based
    authentication. The attempt to use STLS or strong authenticators now causes
    connection abort.

  Configurations using both ssl and sslcertck however have been semi-safe in
  that they would send the password in the clear. The USER/PASS fallback
  problem however applies to these too, so that the password was only safe on
  trustworthy servers.

* CVE-2006-5974, fetchmail-SA-2006-03.txt:
  Repairs a regression in 6.3.5 that crashes fetchmail when a message with
  invalid headers is found while fetchmail's mda option is in use. BerliOS bugs
  #9364, #9412, #9449. Stack backtrace provided by Neil Hoggarth - thanks.

# REGRESSION FIXES (recently introduced bugs)
* Repair --logfile, broken in 6.3.5. BerliOS Bug #9059,
  reported by Brian Harring.
* Repair --user, broken in 6.3.5 (as a side effect of the authenticate external
  patch): using SSL certificate/key authentication overrode the --user option.
  Now the latter takes precedence, and only defaults to the certificate's common
  name.  Debian Bug #400950, reported by Jorgen Schaefer <forcer@debian.org>.

# BUG FIXES (long-standing bugs):
* RPOP: used to log the password locally rather than an asterisk as the other
  protocols do. The password is now shrouded in the local logs.
* POP3: Probes capabilities now when Kerberos V5 is enabled, so that we can
  actually detect if the server supports it.
* Robustness: If a stale lockfile cannot be deleted, truncate it so that
  fetchmail doesn't later believe itself to be running if the PID is recycled
  by a non-fetchmail process.
* DNS: Detect /etc/resolv.conf changes: On systems that have res_search(),
  assume we also have res_init() and call it (suggested by Ulrich Drepper,
  glibc bug #3675) in order to make libc or libresolv reread the resolver
  configuration at the beginning of a poll cycle.  This is important when
  fetchmail is in daemon mode and /etc/resolv.conf is changed later by dhcpcd,
  dhclient, pppd, openvpn or other ip-up/ipchange scripts.  Should fix Debian
  Bug#389270, Bug#391698.
* Robustness: Fix crash on systems that do not provide strdup(), the crash
  happens only in out-of-memory conditions when fetchmail cannot proceed
  anyways.  Patch by Andreas Krennmair.
* Robustness: When HOME and FETCHMAILHOME are unset, be sure to copy user
  database information, so it is not trashed later. Patch by Jim Correia.

# CHANGES:
* Workaround: Improve handling of IMAP IDLE, some servers do not reset their
  time counters after sending information asynchronously. Patch by Sunil
  Shetye, after report from Andrew Baumann.
* Usability: When requesting Kerberos or GSSAPI, complain and exit with syntax
  error if any of these requested features has not been compiled in.  This is
  to fail early and with precise error message. Reported by Isaac Wilcox.
* --version will now add +KRB4 or +KRB5 if Kerberos v4 or v5, respectively, have
  been compiled in. Reported missing by Isaac Wilcox.

# TRANSLATIONS:
* New en_GB (British English) translation by David Lodge.
* Update Japanese (Takeshi Hamasaki), Polish (Jakub Bogusz), Russian (Pavel
  Maryanov) and Vietnamese (Clytie Siddall) translations.
! Note that not all these translations are complete -- this isn't the
  translators' fault though, but due to delays at the BerliOS hosting site and
  the translation project handlers. You may see a few untranslated messages.

# DOCUMENTATION:
* Dropped exit status 15 from manual page, it's not used by fetchmail.
  Reported by Isaac Wilcox.
* Documented exit codes 24 - 29 as internal.

fetchmail 6.3.5 (released 2006-10-09):

# BUG FIXES:
* For protocols such as IMAP that are not delimited by "." lines, truncate the
  input buffer when the message has been completely read, to avoid taking
  trailing garbage into the message if the terminal CRLF is missing. Fixes
  Debian Bug#312415. (Patch suggested by Mike Jones, Manchester Univ.).
* When using NTLM authentication, use regular IMAP response code handler after
  completing NTLM handshake, for robustness and consistency.
  (Taken from the NetBSD portable packages collection, patch-ac.)
* Support Kerberos installations where krb5.h and perhaps roken.h are in
  .../include/krb5.  Taken from NetBSD portable packages collection patch-ae.
* On NetBSD, link against -lroken -lcom_err if --with-kerberos is enabled.
* Drop #include <com_err.h> from Kerberos 5 header file, fixes compile error on
  SUSE Linux 10.0.
* Fix des_pcbc_encrypt compile warnings in kerberos.c line 246.
* If krb5-config provides gssapi library information, use that rather than
  guessing.
* Improve --with-gssapi auto detection for /usr-based GSSAPI installs.
* Fix --with-gssapi builds for NetBSD 3.0.
* Improve KAME/getnameinfo.c portability to Linux libc5 systems.
  Based on a patch by Dan Fandrich.
* Provide INET6 to KAME/getnameinfo.c (only useful on IPv6-enabled systems that
  lack getnameinfo, and there only visible in some Received: headers).
  Found by Dan Fandrich.
* POP3: some UID flags may not be set properly on UIDL lists. (Sunil Shetye)
* Make IMAP4 IDLE work on servers that do not update RECENT counts.
  Reported by Lars Tewes.
* IMAP4 patch by Sunil Shetye:
  - do not depend on server updating RECENT counts at all
  - also enter IDLE loop when messages are present on the server.
* Fix --flush description in the manual page, fetchmail does not mark messages
  seen unless it has successfully delivered them. Suggested by Frederic Marchal.
* Fetchmail no longer attempts to stat the "-" file in daemon mode -- this is a
  special name to read the RC file from stdin, and cannot always be re-read
  anyways. BerliOS bug #7858.
* When looking up ports for a service, the lookup succeeds and the returned
  address family isn't IPv4 or IPv6, properly free the allocated memory from the
  service lookup. Found by Uli Zappe.
* When looking up ports for a service, only look up TCP ports.
* Avoid compiling empty files, to avoid diagnostics from strict compilers.
* If the lockfile ends before the process ID, treat it as stale and unlink it.
  Reported by Justin Pryzby, Debian Bug #376603.
* SIGHUP wake-up behavior was broken since 5.9.13's Cygwin changes, in that for
  non-root users, SIGHUP would abort the first poll and subsequently interfere
  with new polls, and SIGHUP would be ignored for root users. SIGHUP now matches
  documented behavior. SIGUSR1 has always been a wakeup signal for both root
  (undocumented) and non-root users. See also the deprecation warning above.
* Track getaddrinfo() results to properly free them after timeouts and make sure
  that getaddrinfo() isn't interrupted by a timeout (which breaks on MacOS X),
  reported by Uli Zappe.  This should fix Debian Bug#294547 and Bug#377135.
* --logfile is now handled more carefully, errors opening the logfile are
  now reported to the TTY where fetchmail was started from.
* fetchmail now complains and aborts when it cannot properly daemonize itself.
* fix compilation on systems that don't know struct addrinfo (Solaris 2.6).
* ignore SIGPIPE signals and rely on functions to return EPIPE instead. This is
  necessary because the former longjmp() from the signal handler is unsafe and
  makes the whole fetchmail behavior undefined after the event.
* Avoid crash in env.c/host_fqdn if we cannot canonicalize our own hostname.
  Reported by Alexander Holler.
* SSL fix by Miloslav Trmac (Red Hat): free the SSL contexts after the
  connection, to avoid from growing SSL certpaths without bounds, avoid using
  SSL contexts for unrelated connections, and to fix Red Hat Bug #206346.

# CHANGES:
* Rename all fetchmail-internal lock_* functions to fm_lock_*. Obsoletes
  NetBSD portable packages collection patch-ah, patch-ai and patch-aj.
* Configure prints a warning (but proceeds) if Kerberos IV support is enabled.
* In verbose mode, log every IP fetchmail tries to connect to, to avoid
  misleading the user. Suppress EAFNOSUPPORT errors from socket() call, too.
  Fixes Debian Bug #361825, reported by Daniel Baur.
* In idle mode, fetchmail complains about the fetchall option.
* When a connection fails, log not only the IP address, but also host and
  service name and the port number. Log the latter when trying to connect in
  verbose mode, too.
* Keep syslog output at one line per message (this works if no errors occur).
* Fetchmail in verbose mode now logs if it opportunistically upgrades a POP3
  or IMAP connection to TLS security with STLS/STARTTLS.
* fetchmail now supports foo@example.org=bar user mappings for multidrop boxes.
* switch setjmp/longjmp to sigsetjmp/siglongjmp
* IMAP now supports the EXTERNAL authentication method, courtesy of
  Götz 'nimrill' Babin-Ebell, BerliOS patch #1095 with minor changes.
  Note that this change causes --sslcert to override --user.
* The sslproto keywords are now case insensitive, courtesy of
  Götz 'nimrill' Babin-Ebell, BerliOS patch #1095.
* When going to sleep, log for how long.  Suggested by Claudia Ludwig.
* When the server name cannot be canonicalized, log the gai_strerror value.

# TRANSLATION UPDATES:
* Catalan/ca (Ernest Adrogué Calveras), Japanese/ja (Takeshi Hamasaki) - also
  made gettext 0.15 ready, Polish/pl (Jakub Bogusz), Russian/ru (Pavel
  Maryanov), Spanish/es (Héctor García Álvarez), Vietnamese/vi (Clytie Siddall)

# CONTRIBUTED SCRIPTS:
* PopDel.py was revised by Joshua Crawford to display the From: address and
  list every email, even if it has no Subject: header; and not delete the wrong
  message in the presence of mail without Subject: headers.

fetchmail 6.3.4 (released 2006-04-14):

# BUG FIXES:
* configure: detect res_* functions properly with newer glibc ABIs.
  Patch by Miloslav Trmac.
* tracepolls: add folder information if available. Reported by Terry Brown.
* lexer: add %option noyywrap to avoid link errors about missing yywrap().
* a few more type fixes for report/snprintf, patch by Miloslav Trmac.
* bouncing: fetchmail would still send "General SMTP/ESMTP error." bounces
  in spite of "no bouncemail" configuration.
* SSL/TLS: if, for a certain server, an sslfingerprint is specified and
  sslcertck is NOT set, suppress printing SSL certificate mismatch errors.
  (Reported by Hannes Erven.)
* SSL/TLS: always print if the sslfingerprint mismatches, even in silent
  mode.  (This is for consistency with certificate verification errors.)

# TRANSLATION UPDATES:
* German/de (Matthias Andree), French/fr (Matthias Andree), Spanish/es (Héctor
  García), Polish/pl (Jakub Bogusz), Japanese/ja (Takeshi Hamasaki)
* New Vietnamese/vi translation (Clytie Siddall).
* Updated French descriptions for the .spec file (Stéphane Schildknecht,
  Luc Pionchon, Matthias Andree).

# CHANGES:
* pidfile: there is a new command-line (--pidfile PATH) and global option for
  the rcfile (set pidfile [=] "/path/to/pidfile") option to allow overriding
  the default location of the PID file.
  Requested by Héctor García, Debian maintainer.
* specgen.sh: Converted to UTF-8 to support translated texts better.

fetchmail 6.3.3 (released 2006-03-30):

# BUG FIXES:
* SEGFAULT: Do not attempt to overwrite the netrc password if none has been
  specified.  This fixes a segmentation fault bug introduced into 6.3.2.
  Fixes BerliOS bug #6234.  BerliOS patch #804 by Craig Leres.
  The patch, as accepted into fetchmail, was available separately from
  <http://download.berlios.de/fetchmail/patch-6.3.2.1-fix-netrc-SIGSEGV.diff>
* SEGFAULT: Work around C libraries that return a NULL in getaddrinfo()'s
  ai_canonname record, to avoid a segfault. Affects for instance FreeBSD 4.10,
  4.11 and 5.3 when dotted quads are given as server names.
  Analysis and fix by Vladimir Olegovich Ravodin (Владимир Олегович Раводин).
* IMAP: fix hangs in NOOP-based IDLE emulation. Reported by Casper Gripenberg
  and Brendan Lynch, fix by Sunil Shetye (his patch was merged) and Brendan Lynch.
* IMAP: Handle other clients concurrently accessing IMAP mailboxes better.
  Fetchmail quits the poll if the EXPUNGE count does not match expectations, and
  servers not updating RECENT counts after EXPUNGE are handled in a better way.
  (Patch by Sunil Shetye.)
* IMAP: Stop sending EXPUNGE after NOOP-idling (patch by Sunil Shetye).
* POP3: fetchmail can now use UIDL in fetchall keep mode, to avoid re-fetching
  the same messages again when the fetchall keyword is removed. Patch by
  Sunil Shetye. For details, please see
  <http://lists.berlios.de/pipermail/fetchmail-users/2006-March/000308.html>
* LMTP: fix bug in LMTP port validation (patch by Miloslav Trmac).
* SDPS: fetchmail no longer replaces the local user ID for an empty envelope
  sender when using the proprietary SDPS extension for POP3.
  Fixes Debian Bug#353575, reported by Roger Lynn.
* SDPS: Warn and disable SDPS if POP3 is disabled to avoid compilation errors.
* fetchmail no longer prints empty lines in verbose mode when using syslog.
* fetchmail no longer prints UID lists in verbose mode when using syslog.
* ./configure --quiet is now quieter (no SSL and fallback-related output).
* Miloslav Trmac's patch (with minor changes) to fix char * sign consistency,
  unused arguments and variables.
* More signedness, unused argument/variable and other warning fixes.

# CHANGES:
* --idle can now be specified on the command line, too.
* --fetchall is now supported on the command-line.
* POP3: Lower default fastuidl span to 4 (i. e. every 4th run fetches the
  whole UIDL list), patch by Sunil Shetye.

# DOCUMENTATION:
* "ssl" is a user option rather than a server option. Patch by Nico Golde.
  Fixes Debian Bug#354661, reported by Keith Hellman.
* The manual page now suggests "--" before the addresses in the sendmail MDA
  example, for safety.
* The FAQ item X9, Domino IMAP omits Content-Transfer-Encoding header, was
  added. Information provided by Anthony Kim on the fetchmail-friends list
  in March 2006.
* Credit Chris Boyle with the NOOP emulation code for IDLE in fetchmail 6.2.4.
  Eric forgot to credit Chris, thanks to Sunil Shetye for providing these links:
  http://lists.ccil.org/pipermail/fetchmail-friends/2003-July/007705.html
  http://lists.ccil.org/pipermail/fetchmail-friends/2003-July/007713.html
* Added a section about RETR vs. TOP to the manual page.
* Changed section/subsection levels in some areas.

fetchmail 6.3.2 (released 2006-01-22):

Unless otherwise noted, changes to this release were made by Matthias Andree.

# SECURITY FIX IN THIS RELEASE
* CVE-2006-0321: Fix segfault or bus error after bouncing a message.  This bug
  was introduced into 6.3.0 when removing alloca(); it caused fetchmail to free
  random memory.  Reported by Nathaniel W. Turner, Debian Bug#348747.
  See fetchmail-SA-2006-01.txt

# INCOMPATIBLE CHANGE:
* Automatically disable the POP3 TOP command if the greeting string contains
  "Maillennium POP3/PROXY server", which is used by comcast and known to
  truncate messages after 80 kByte. Fall back to RETR, and complain if we had
  used TOP otherwise (the warning is printed only once per server in daemon
  mode).  Suggested by Ed Wilts.
  *Note* that this means messages are marked read on these servers, which is a
  deviation from how 6.3.1 behaved, but we have no alternative, comcast haven't
  fixed this bug in years.  Preventing the loss of the remainder of the message
  justifies this incompatible fix.
* fetchmail, since 6.3.0, requires write permission to the directory holding the
  idfile. See the amendment in the 6.3.0 MAJOR INCOMPATIBLE CHANGES section
  below for details. The manual page was updated.

# CHANGES RELEVANT TO PACKAGERS:
* The outdated BUGS document was removed from the distribution.
* Added fetchmail-SA-2006-01.txt to the distribution.

# BUG FIXES:
* SMTP/LMTP cleanup to fix these two bugs:
  - switch back to SMTP after having tried LMTP hosts (multiple smtphost hosts)
  - switch back to LMTP after sending a bounce.
  The patch removes the global state variable that was the root of this problem.
  Patch by Sunil Shetye. (MA)
* Don't complain about fetchall keep in --configdump mode. Bug introduced in
  6.3.0.
* fetchmailconf.py: Fix novice help for Poll interval and fetchall.
  Reported by Justin Pryzby, Debian Bug #344978.
* Some verbose output disappeared in debug mode. Adding further -v options would
  alternate between verbose and debug mode. debug mode now comprises all verbose
  output, and adding more -v options does not switch back from debug to verbose
  mode.
* fetchmail.man: Fix accented characters in Héctor García's name. Merged from
  downstream debian/patches/01_man_page.dpatch.
* Add missing --help text for "--sslcertck" option.
* fetchmailconf.py: Accept --help and --version.
* fetchmail --version  now prints the copyright notice.
* don't complain about READ-ONLY IMAP folders in --fetchall --keep mode.
  Reported Alexander Zangerl, Debian Bug#348964.
* the RPM .spec file now generates a -debuginfo package on newer RPM versions.

fetchmail 6.3.1 (released 2005-12-19):

# SECURITY FIX IN THIS RELEASE
* CVE-2005-4348 Fix segmentation fault (null pointer dereference) in
  multidrop mode with headerless email.  See fetchmail-SA-2005-03.txt.
  Reported by Daniel Drake, patch by Sunil Shetye. (MA)

# OTHER BUG FIXES, DOCUMENTATION AND TRANSLATION UPDATES
* Fix broken default port in POP2. Patch by Stanislav Brabec, SUSE [CZ]. (MA)
* Fix manual page, some lines starting with ' were escaped by \&.
  Reported by Simon Barner. (MA)
* Ship with gettext-0.14.3 again, as 6.2.9-rc10 did. Found by Sunil Shetye. (MA)
* Actually set default SSL certificate path if --sslcertpath is unset.
  Reported by Heino Tiedemann and Rob MacGregor. (MA)
* Remove bogus Netscape IMAP4rev1 Service >= 3.6 warning about BODY[TEXT]
  that we are not using. Patch by Sunil Shetye. (MA)
* Plug potential memory and socket leak when polling multiple folders or when
  the upstream sends bogus message sizes.  Patch by Sunil Shetye. (MA)
* Update Catalan translation, by Ernest Adrogué Calveras. (MA)
* Fix segfault (null pointer dereference) on some operating systems with
  fetchmail's obsolete DNS MX/host alias lookups in multidrop mode.
  Patch by Dr.-Ing. Andreas Haakh. (MA)
* Close SMTP sockets early, to reduce resource usage, trigger earlier delivery
  with some MTAs and avoid SIGPIPE (SIG 13) when the SMTP listener gets bored
  and drops the connection after timeout.  Patch by Sunil Shetye. (MA)
* Don't treat hitting a fetch limit as error.  Patch by Sunil Shetye. (MA)
* Fix negative "messages left on server" on idle/repoll with fetchlimit.
  Patch by Sunil Shetye. (MA)
* Properly track logout stage.  Patch by Sunil Shetye. (MA)
* Preserve error conditions across postconnect script.  Sunil Shetye. (MA)
* Do not trash destination domain if multiple messages are forwarded into the
  same SMTP/LMTP connection. Reported by Joachim Feise, Berlios Bug #5849. (MA)
* Manual page: Add "-md5" to "openssl x509" example in --sslfingerprint
  documentation, since OpenSSL 0.9.8 changed the default to SHA1.
  Suggested by Jason White. (MA)
* Cope with servers that return UID information in response to non-UID
  RFC822.{SIZE|HEADER} requests. Reported by Jason White.
  Patch suggestion by by Sunil Shetye, simplified by MA.

fetchmail 6.3.0 (released 2005-11-30):

# SECURITY FIXES IN THIS RELEASE
* CVE-2005-2335: The POP3 UIDL code doesn't sufficiently validate/truncate the
  input length, so a (malicious or compromised) server that sends UIDs longer
  than 128 bytes can corrupt fetchmail's stack and crash fetchmail.
  This vulnerability is remotely exploitable to inject code run in a
  root shell. Edward J. Shornock, Ludwig Nussel. fetchmail-SA-2005-01.txt
* CVE-2005-3088: fetchmailconf now changes the output file to mode 0600 BEFORE
  writing to it, so there is no window where passwords could be read by the
  world. Matthias Andree. fetchmail-SA-2005-02.txt

# MAJOR INCOMPATIBLE CHANGES
* Remove support for --netsec/-T options, the required inet6_apps library is no
  longer available.
  http://www.inner.net/pub/ipv6/ states, as of 2005-07-03: "/pub/ipv6
  Our IPv6 software is now long defunct. Please find a more modern source."
  I haven't been able to find a more modern source.  Matthias Andree
* Operating systems that do not conform to the Single Unix Specification v2
  (1997) or v3 (2001, aka IEEE Std 1003.1-2001) are no longer supported. They
  may continue to work and non-intrusive patches to support them may be
  accepted.  Matthias Andree
* The default for --smtphost is now always "localhost" regardless of
  authentication types and protocols, so as to simplify configurations for
  workstations where the SMTP daemon only listens on the loopback interface.
  Sunil Shetye & Matthias Andree
Amendment, 2006-01-04:
* fetchmail's idfile (.fetchids) is no longer written directly, but the ids are
  written to a temporary file which is renamed into place after being written
  completely. This is to avoid writing incomplete idfiles when running out of
  space, which would cause excessive duplicate refetches of messages, this might
  make matters even worse. This means that fetchmail requires write permission
  on the directory holding the idfile. This will usually affect system-global
  daemons only, for instance, Debian. Found by Dan Jacobson. Matthias Andree.
Escalated to "incompatible", 2006-01-13:
* Try to obtain FQDN as our own host by default, rather than using "localhost".
  If hostname cannot be qualified, complain noisily and continue, unless
  Kerberos, ODMR or ETRN are used (these have always required an FQDN).
  Partial fix of Debian Bug#150137. Fixes Debian Bug#316454.  Matthias Andree

# CHANGES RELEVANT TO PACKAGERS AND USERS
* fetchmailconf is now a shell wrapper that calls the byte-compiled
  fetchmailconf.py script, which is now installed in the regular python
  directory. Matthias Andree.
* The --enable-inet6 configure option was removed. The code is mostly protocol
  agnostic, a fully IPv6 aware OS is expected to provide getaddrinfo(),
  getnameinfo() and the macro AF_INET6.  Matthias Andree.
* gettext (intl/) has been removed from the fetchmail package. Install GNU
  gettext 0.14 separately for NLS (i18n).  Matthias Andree
* Added Russian translation, courtesy of Pavel Maryanov of the
  Russian translation team. (MA)
* Updated and re-enabled Czech translation, by Miloslav Trmac (MA).
* Dropped da=Danish, el=Greek and tr=Turkish translations which have more than
  10% (61+) untranslated or fuzzy messages.  Matthias Andree.

# OTHER USER-VISIBLE CHANGES
* Sunil Shetye's fix to force fetchsizelimit to 1 for APOP and RPOP. (ESR)
* PopDel.py removed from contrib at author's request. (ESR)
* Matthias Andree's fix for Sunil Shetye's fetch-split patch. (ESR)
* Include James Stone's moldremover.py script. (ESR)
* Enable .fetchmailrc permissions checking under Cygwin. (ESR)
* Nalin Dahyabai's fix for POP3 strong authentication. (ESR)
* Revised Nalin Dahyabai's fix for POP3 strong authentication (the
  original version would go into an infinite loop when CAPA failed;
  found by David Greaves.) (MA)
* HOME_ETC patch for PLD Linux. (ESR)
* Sunil Shetye's fix for SSL configuration. (ESR)
* Simon Josefsson's patch for GSS library support. (ESR)
* Added Andrey Lelikov's recipe for Hotmail and Lycos Webmail. (ESR)
* Remove blank between MAIL FROM: and <, which causes Cyrus to complain.
  Patch by Phil Endecott. (RF)
* Build fixes for HESIOD and resolv.h trouble on FreeBSD. (MA)
* Fabrice Bellet's fix for Red Hat bug #113492, fetchmail hangs in IMAP
  mode after EXPUNGE when the server (Dovecot 0.99.10) doesn't update
  RECENT and EXISTS counts. (MA)
* Holger Mauermann's bounce patch, to use a NULL envelope from, not
  write a Return-Path header (both to meet RFC-2821), changed From,
  added Subject header, rewording the human readable part.  Fixes Debian
  bug #316446. (MA)
* Merge Sunil Shetye's time.h handling fix. (MA)
* Merge Gerd von Egidy's patch to avoid a segfault in multidrop/received
  mode when the Received: headers are malformatted. (MA)
* MIME-encode bodies and Subject headers of warning messages, limiting
  the header to 7 bits. (MA)
* Normalize most locale codesets to IANA codesets, based on
  norm_charmap.c by Markus Kuhn. (MA)
* Remove sleep(3) after POP3 login, patch by Brian Candler. (MA)
* Fix option parsing bug that trashes the showdots setting when more
  than one server is configured. Patch by Brian Candler. (MA)
* Honor sslcertpath setting even if sslcertck is unset. Patch by Brian
  Candler. (MA)
* SSL certificate checking fixes, don't display same error message twice
  in succession, make sure that Common Name and fingerprint checking are
  only done once. Print all validation warnings/errors even if not in
  verbose mode. Patch by Brian Candler. (MA)
* Import Bjorn Reese and Daniel Stenberg's MIT-licensed Trio 1.10 from
  http://daniel.haxx.se/projects/trio/ for systems that do not support
  snprintf or vsnprintf. (MA)
* Clean up the horrible #ifdef HAVE_[V]SNPRINTF that made the code
  unreadable. Use Trio where [v]snprintf is/are missing. (MA)
* Default to Linux 2.2 /proc/net/dev format, and use uname(2) to determine the
  kernel version instead of calling uname(1). Thanks to Paul Slootman.  (MA)
* Be more careful when swapping UID lists or writing the .fetchids file,
  requested by Manfred Weihs. (MA)
* Print a warning if multidrop configuration is attempted without
  envelope option. (MA)
* Split information on fetchmail versions before 6.0.0 to a separate
  OLDNEWS file. (MA)
* Merge SuSE patches: (sent by Stanislav Brabec, merged by Matthias Andree)
  - fetchmail-6.2.5-declaration.patch (double sigint_handler decl/getpass.c)
  - fetchmail-6.2.5-implicit-declaration.patch (missing #include)
  - fetchmail-6.2.5-random-result.patch (uninitialized variable/opie.c)
* Revised some bogus assertions about POP3 LAST and UIDL use in the
  manual page. UIDL isn't flaky as the man page suggested, but a
  reliability feature. In fact, IMAP4 code is flaky in that it relies on
  the upstream seen flags. (MA)
* Miloslav Trmac's patch for fetchmailconf to support string-type values
  of the "port" variable, avoiding "port None" corruption in .fetchmailrc.
  To fix Redhat Bug #55623 (MA)
* de.po fixes from Nico Golde (MA)
* es.po fixes from Jesus Roncero, Debian bug #286044 (MA)
* sink.c fix from Cesar Eduardo Barros, to avoid double @ in address
  when username contains an @ and the envelope sender is null, Debian
  bug #272289 (MA)
* configure.ac cleanups by Miloslav Trmac (MA)
* Miloslav Trmac's fix to reply_hack() type, for systems where
  sizeof(int) != sizeof(size_t). (MA)
* Nalin Dahyabhai's fix for driver.c to not call the private Kerberos
  krb5_init_ets() function. Sent by Miloslav Trmac. (MA)
* Nalin Dahyabhai's fix for sink.c/transact.c to reserve sufficient
  space for \r\n trailers in snprintf calls. Sent by Miloslav Trmac,
  possibly fixing Red Hat bug #114470. (MA).
* Nalin Dahyabhai's patch to use the krb5-config script, if present.
  Sent by Miloslav Trmac. (MA)
* Nalin Dahyabhai's fix to make rpa.c compile. Sent by Miloslav Trmac. (MA)
* Trivial fetchmailconf.man to redirect to fetchmail.1.
  Reported by Miloslav Trmac. (MA)
* Internationalization (i18n) updates by Miloslav Trmac. (MA)
* Fix "couldn't find canonical DNS name of NN (MM)" for hosts that have
  only IPv6 addresses. Matthias Andree.
* Revised INSTALL after question from Brian Candler, inet6-apps is no
  longer available: remove inet6-apps hints for IPv6, and add some
  apologetic message for IPsec. Note the code may be removed in a future
  version. Matthias Andree.
* Brian Candler's FAQ update about SSL certificate verification. (MA)
* Nico Golde's patch to support "proto RPOP" in the configuration file,
  reported by Dr. Andreas Krüger, Debian bug #242384 (MA)
* Skip sending POP3 PASS command when USER command failed. Matthias Andree.
* Run fetchmail.man through automatic spell checker. Matthias Andree.
* Major fetchmail(1) manual page overhaul by R. Hannes Beinert, to
  clarify singledrop vs. multidrop operation. (MA)
* Make tracepolls a server option, as documented. Fixes Debian bug
  #156094. Matthias Andree.
* Fix some minor inaccuracies (RFC-1893 related, grammar/spelling) in
  the manual page.
* Rename ESR's design notes to esrs-design-notes.html and add a new
  design-notes.html document. The NOTES file will contain both of them.
  Matthias Andree.
* Fix Debian bug #301964, fetchmail leaks sockets when SSL negotiation
  fails. Fix suggested by Goswin Brederlow. (MA)
* Really fix Debian Bug#207919 (garbage in Received: lines when smtphost set),
  patch by Tobias Diedrich.  The 6.2.5 NEWS claimed Gregan's patch had fixed
  #207919 but it had fixed #212484 instead and #207919 remained unfixed in
  6.2.5. The entry below has been corrected to read #212484 now. (MA)
* When writing the PID file, write a FHS 2.3 compliant PID file.
  Fixes Debian bug #230615. Matthias Andree.
* Make ODMR really silent, suppress "fetchmail: receiving message
  data". Fixes Debian Bug#296163. Matthias Andree.
* Add From: header to warning emails. Debian Bug#244828. Matthias Andree.
* Fix IMAP code to use password of arbitrary length from configuration
  file (although not when read interactively). Debian Bug#276424.
  Matthias Andree
* Document that fetchmail may automatically enable UIDL option.
  Debian Bug#304701. Matthias Andree.
* Put *BOLD* text into the manual page near --mda to state unmistakably that
  the --mda %T and %F substitutions add single quotes, hoping to avoid bogus
  bug reports such as Debian Bug #224564. Matthias Andree
* Rename lock_release to fm_lock_release, to avoid namespace collision on
  Darwin. NetBSD PR#28543 (pkg/28543). Matthias Andree.
* The RFC-822 parser no longer strips the last character of bare addresses.
  Matthias Andree
* The IP address matching code was broken and 
  1. didn't search exhaustively, but matched only the first IP address of the
  server's queryname against the IP addresses of the server name to match.
  2. didn't match IP aliases versus MX hosts.  Matthias Andree
* The "port" option, while still understood, is being replaced by the "service"
  option, which is now supported even without --enable-inet6. Matthias Andree.
* The default distribution format is now bzip2. Matthias Andree.
* fetchmailconf redirects fetchmail's input from /dev/null so it doesn't
  wait for the user to enter a password when the user doesn't even see
  the prompt. Reported by Michal Marek. Matthias Andree.
* Write RFC-compliant BSMTP envelopes. Reported by Nico Golde. Matthias Andree.
* Fix --with-gssapi compilation problem. Simon Josefsson. (MA)
* Foster protocol-independence to support IPv6 better, for instance, providing
  IPv6 addresses in Received: headers. Matthias Andree.
* Received: headers now enclose the for <...> destination address in angle
  brackets for consistency with Postfix.  Matthias Andree.
* Operating systems that do not support at least one of gethostbyname,
  gethostbyname_r, getipnodebyname are no longer supported.  Matthias Andree.
* Fixes to --with-hesiod option. Sunil Shetye. (MA)
* Delete oversized messages with the new --limitflush option. Debian
  Bug#212240. Sunil Shetye. (MA)
* Fix MacOS X compilation failures in sink.c (ru_*time has incomplete type).
  Berlios Bug #4725. Matthias Andree.
* Fix "auth ntlm" to send AUTH NTLM (rather than AUTH MSN). Add "auth msn"
  officially. Reported by Yves Boisjoly. Matthias Andree
* Expunge between IMAP folders when polling multiple folders.
  Sunil Shetye. (MA)
* Fix IMAP expunged message counting. Sunil Shetye. (MA)
* Add full support for --service option. Matthias Andree
* When getaddrinfo() fails resolving a service, log getaddrinfo() error. (MA)
* Fix bogus "cannot resolve service * to port number" error. Simon Barner. (MA)
* Failure to set up SSL connections now results in PS_SOCKET. Suggested by
  Thomas Wolff. Matthias Andree.
* Kerberos IV detection fix for FreeBSD 4. Simon Barner. (MA)
* Fix display and documentation of --envelope option. Matthias Andree
* Make "envelope 'Delivered-To'" work with dropdelivered. Timothy Lee. (MA)
* Add -DBIND_8_COMPAT to Darwin (MacOS X) compiles, to fix build problems on
  newer Darwin versions. Matthias Andree.
* fetchmail should now automatically detect if OpenSSL requires -ldl.
  Matthias Andree.
* Fix Solaris build with --disable-nls (blastwave.org). Matthias Andree.
* Missed --port/--service/--ssl cleanups in the manual. Reminder from Thomas
  Wolff. (MA)
* Complain in POP3 if NTLM/MSN auth is requested but had not been enabled at
  compile time. This configuration mismatch now causes an error message and
  authentication failure. Found by Yves Boisjoly.  Matthias Andree
* fetchmailconf now allows expert users to choose the authorization type and
  also offers MSN and NTLM, suggested by Yves Boisjoly. Matthias Andree
* fetchmailconf now (as of 1.49) writes its version to the comment of the
  saved run control file. Matthias Andree
* Properly shut down SSL connections. Berlios Patch #647 by Arkadiusz
  Miśkiewicz. (MA)
* Global variable cleanup, to fix daemon mode reinitialization problems. Patch
  by Sunil Shetye. (MA)
* fetchmailconf -h documents the fetchmailconf -h option. Matthias Andree
* fetchmailconf -V now prints the fetchmailconf version. Matthias Andree
* Add support for SubjectAltName (RFC-2595 or 2818), to avoid bogus certificate
  mismatch errors. Patch by Roland Stigge, Debian Bug#201113. (MA)
* make fetchmail --silent --quit really silent, Debian Bug #229014 by Dr.
  Andreas Krüger.  Matthias Andree
* cleanup --quit handling again (so that --silent --quit just kills the
  existing daemon, rather than continue running), and document it more clearly.
  Matthias Andree
* Print an error message if multiple "defaults" records are found in the
  configuration file.  Matthias Andree
* Bury on_exit officially - the necessary code had been missing from 6.0.0,
  6.2.0, 6.2.5.  Matthias Andree
* Exit with error if the lock file cannot be read.  Matthias Andree
* Exit with error if the lock file cannot be created exclusively, this got
  broken in a 6.2.6-pre, 6.2.5.2 and older were fine.  Matthias Andree
* Do not break some other process's lockfile in "-q" mode, but wait for the
  other process's exit.  Matthias Andree
* Man page: --sslfingerprint points user to x509(1ssl) and gives an example
  how to use it. Debian Bug#213484, Eduard Bloch. (MA)
* fetchmailconf now sets the service properly after autoprobe. Fixes Debian
  Bug#320645.  Matthias Andree
* Man page: Fix Debian Bug#241883, making global options more clear. Matt
  Swift, Matthias Andree.
* When eating IMAP message trailer, don't see any line containing "OK" as the
  end of the trailer, but wait for the proper tagged OK line. To work around
  the qmail + Courier-IMAP problem in Debian Bug#338007. Matthias Andree
* Fix Debian Bug#317761: when trying to send a bounce message, don't bail out
  if we cannot qualify our own hostname, so we aren't losing the bounce.
  Instead, pass the buck on to the SMTP server and use our own unqualified
  hostname. Matthias Andree
* Revise some error messages so they are less confusing. Sunil Shetye.
* Man page: update --smtphost documentation. Sunil Shetye, Matthias Andree.
* Man page: clarify --loghost works only while detached. Matthias Andree
* Man page: update --smtpaddress documentation. Sunil Shetye.
* Fix several memory leaks and bugs in the SMTP/LMTP retry logic where
  fetchmail confused UNIX and Internet domain sockets. Sunil Shetye.
* Man page (BUGS): document that passwords are length limited. Matthias Andree
* Man page: Document that quoted strings that run across line boundaries
  contain the control characters (CR or LF). Document explicitly the backslash
  escape sequences and their differences from the escape sequences used in the
  C programming language.  Matthias Andree
* Fix segfault when run control file ends with a backslash inside an
  unterminated quoted string. Matthias Andree.
* In quoted strings, support backslash as last character on a line to join the
  following line to the current. Matthias Andree.
* Parsing untagged IMAP responses is more robust now. Matthias Andree.
* Man page: Remove some procmail praises in --mda documentation, suggest
  maildrop instead, warn of procmail fallthrough behavior. Matthias Andree.
* Man page: Revise AUTHORS and SEE ALSO sections. Matthias Andree.
* Updated translations: Albanian [sq] (Besnik Bleta), Catalan [ca] (Ernest
  Adrogué Calveras), Czech [cs] (Miloslav Trmac), German [de] (MA),
  Spanish (Castilian) [es] (Javier Kohen), French [fr] (MA),
  Polish [pl] (Jakub Bogusz), Russian [ru] (Pavel Maryanov).
* In oversized warning messages, print the account name, too. Fixes Debian
  Bug#213299. Sunil Shetye (MA).
* Fix installation without Python. Sunil Shetye, reported by Peter Church. (MA)
* Update Japanese translation. Fixes Debian Bug#329342, Takeshi Hamasaki. (MA)
* Fix imap.c size safeguard that broke on x86_64 architecture. Matthias Andree
* The FAQ is now available for duplex DIN A4 printing in PDF format.
  Don't bother to ask for a Letter version, I don't care.  Matthias Andree
* Man page: Use \- in the manual page where appropriate so that copy & paste
  works.  I hope we got them all.  Héctor García, Matthias Andree.

# INTERNAL CHANGES
* Switched to automake. Matthias Andree.
* Got rid of alloca() in fetchmail proper.  Matthias Andree
* Got rid of ipv6-connect, inner_connect and thereabouts.  Matthias Andree

--------------------------------------------------------------------------------

fetchmail-6.2.5 (Wed Oct 15 18:39:22 EDT 2003), 23079 lines:

* Updated Spanish, Turkish, and German translation files.
* Matthew Gregan's patch to handle garbage lengths from dbmail;
  closes Debian bug #212484.
* Fix IMAP query so new-message count doesn't include deleted messages.
* Man page typo fix, closes Debian bug #205892.
* OpenSSL cleanup patches from levinedl@acm.org.
* Benjamin Drieu's patch to fix Debian bug #212240, no oversized-message
  flushing if both "flush" and "limit" were specified.
* Benjamin Drieu's patch for Debian bug #156592, incorrect handing of 
  host/port option.
* Smash all NULs out of headers right after the socket read.
* Dup-killer code now keys on an MD5 hash of the raw headers.
* Sunil Shetye's patches to break up fetching of sizes and UIDLs.

There are 599 people on fetchmail-friends and 748 on fetchmail-announce.

fetchmail-6.2.4 (Wed Aug 13 04:27:35 EDT 2003), 22625 lines:

* Updated German, Spanish, Catalan, and Turkish translations.
* IDLE is now supported using NOOP commands even if the server doesn't support
  the IMAP IDLE extension. Patch by Chris Boyle.
* Sunil Shetye's patch to do better password shrouding.
* Sunil Shetye's bug-fix rollup patch.
* Introduce a translation item for the word "seen".
* Back out the hack to deal with lack of byte stuffing on some POP3 servers.
* Thomas Steudten's patch to improve SMTP handling of 550 errors.

There are 585 people on fetchmail-friends and 745 on fetchmail-announce.

fetchmail-6.2.3 (Thu Jul 17 14:53:00 EDT 2003), 22490 lines:

* French, German, Danish, Spanish, and Turkish translations updated.
* Brian Sammon's patch to deal with malformed message lines containing NULs.
* Fai's patch to ignore all but the first Return-Path (some spams have
  more than one of these).
* Benjamin Drieu's patch to properly byte-stuff when talking to BSMTP.
  Fixes Debian bug #184469.
* Benjamin Drieu's patch to enable auth=cram-md5.
  Fixes Debian bug #185232.
* Sunil Shetye's configure.in patch to avoid spurious search order messages
  from GCC.
* Header-reading code now copes better with lines ending in \n only.
* Elias Israel's patches for POP3 NTLM support and dealing with byte-
  stuffing failures at socket level.

There are 580 people on fetchmail-friends and 750 on fetchmail-announce.

fetchmail-6.2.2 (Fri Feb 28 21:34:26 EST 2003), 22345 lines:

* Sunil Shetye's patch to improve behavior on empty messages.
* Conform to RFC2595; reissue capability probes after successful 
  STARTTLS negotiation.
* Sunil's patch to make handling of failed STARTTLS more graceful.
* Sunil's JF2 fix patch for .fetchmailrc security.
* Christophe GIAUME <christophe@giaume.com> finished the implementation
  of RFC2177 IDLE.
* Jason Tishler's fix patch for Cygwin.
* Support ssh-style authentication in POP3
* Fix for Debian bug #108977, clean up config file evaluation,
  by Benjamin Drieu.

There are 554 people on fetchmail-friends and 727 on fetchmail-announce.

fetchmail-6.2.1 (Tue Jan 14 08:17:19 EST 2003), 22219 lines:

* Updated German, Turkish, Spanish, and Danish translation files.
* Integrated Sunil Shetye's patch to make mark_seen an explicit method.
* Removed FAQ warning about GMX and associated fetchmailconf check, 
  we have a report that its servers are conformant now.
* Another Sunil patch to fix a minor bug in bouncemail generation.

There are 536 people on fetchmail-friends and 716 on fetchmail-announce.

fetchmail-6.2.0 (Fri Dec 13 00:10:07 EST 2002), 22235 lines:

* Applied Steffen Esser's fix for a buffer-overflow bug in rfc822.c
* Updated Danish, German, and Turkish translation files.
* Sunil Shetye's SMTP timeout patch.

There are 538 people on fetchmail-friends and 701 on fetchmail-announce.

--------------------------------------------------------------------------------

fetchmail-6.1.3 (Thu Nov 28 05:35:15 EST 2002), 22203 lines:

* Updated Turkish, Danish, German, Spanish, Catalan po files.
* Added Slovak support.
* Configure.in update for autoconf 2.5 (Art Haas). 
* Be case-insensitive when looking for IMAP responses.
* Fix logout-after-idle-delivery bug (Sunil Shetye).
* Sunil Shetye's patch to bulletproof end-of-header detection.
* Sunil's fix for the STARTTLS problem -- repoll if TLS nabdshake
  fails.  The attempt to set up STARTTLS can be suppressed with 'sslproto ""'.

There are 540 people on fetchmail-friends and 701 on fetchmail-announce.

fetchmail-6.1.2 (Thu Oct 31 11:41:02 EST 2002), 22135 lines:

* Jan Klaverstijn's verbosity-lowering patch.
* Updated Turkish, German, Catalan, and Danish translation files.
* Fix processing of POP3 messages with missing bodies.
* Minor fixes by Sunil Shetye: fix generation of auth fail note, handle
  unexpected SIGALRM, plug memory leak, handle lines beginning with '\0',
  try to bulletproof error handling against read failures.

There are 535 people on fetchmail-friends and 696 on fetchmail-announce.

fetchmail-6.1.1 (Fri Oct 18 14:53:51 EDT 2002), 22087 lines:

* OTP fix patches from Stanislav Brabec <utx@penguin.cz>
* fix patch for writing antispam capability correctly in conf.c.
* Fix patches for Debian bugs #162571, #156592.
* Correction to manpage re -b and qmail.
* Patch to disable use of STLS if auth passwd is specified.
* Fix specfile generation to handle SSL correctly.
* New Danish, Turkish, and Catalan translation files.
* Improved ODMR debug messages.
* IMAP efficiency hack; don't fetch sizes unless needed.
* Detect and rewrite invalid return paths beginning with @.
* Fix for subtle freeing bug that suppressed information in some bounce msgs.
* Newline fix patches for internationalization files.
* Fix reversed test guarding authentication-failure warnings.
* Fix POP3 breakage starting at 5.9.14.

There are 529 people on fetchmail-friends and 693 on fetchmail-announce.

fetchmail-6.1.0 (Sun Sep 22 18:31:23 EDT 2002), 21999 lines:

* Updated French translation.
* Stefan Esser's fix for potential remote vulnerability in multidrop mode.
  This is an important security fix!

There are 519 people on fetchmail-friends and 680 on fetchmail-announce.

--------------------------------------------------------------------------------

fetchmail-6.0.0 (Tue Sep 17 19:48:25 EDT 2002), 21972 lines:

* Applied Matt Kraai's fix for minor Debian bug #144539.
* Nerijus Baliunas's patch to support STARTTLS over IMAP.
* More cleanups and minor bugfixes from Sunil Shetye.
* Default antispam-response list is now empty.
* Updated de and po translations.

--------------------------------------------------------------------------------

There are 520 people on fetchmail-friends and 683 on fetchmail-announce.

--------------------------------------------------------------------------------

 vim:tw=80 com=bf\:* ts=8 sts=8 sw=8 ai:
